(function(){
"use strict";
var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var DomUtil = {CLASS_NAME_SELECTOR_PREFIX_:".", REFLOW_ATTRIBUTE_NAME_:"gwd-reflow", NodeType:{ELEMENT:1, ATTRIBUTE:2, TEXT:3, CDATA_SECTION:4, ENTITY_REFERENCE:5, ENTITY:6, PROCESSING_INSTRUCTION:7, COMMENT:8, DOCUMENT:9, DOCUMENT_TYPE:10, DOCUMENT_FRAGMENT:11, NOTATION:12}, selectByClassName:function(root, className) {
  return root.querySelector(DomUtil.CLASS_NAME_SELECTOR_PREFIX_ + className);
}, contains:function(parent, descendant) {
  if (parent.contains && descendant.nodeType == DomUtil.NodeType.ELEMENT) {
    return parent == descendant || parent.contains(descendant);
  }
  if ("undefined" != typeof parent.compareDocumentPosition) {
    return parent == descendant || Boolean(parent.compareDocumentPosition(descendant) & 16);
  }
  for (;descendant && parent != descendant;) {
    descendant = descendant.parentNode;
  }
  return descendant == parent;
}, maybeLoadElement:function(element) {
  if ("function" == typeof element.gwdLoad && "function" == typeof element.gwdIsLoaded && !element.gwdIsLoaded()) {
    var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsLoaded = wrapperPage && "function" == typeof wrapperPage.gwdIsLoaded;
    (!wrapperPage || wrapperPageImplementsIsLoaded && wrapperPage.gwdIsLoaded()) && element.gwdLoad();
  }
}, maybeActivateElement:function(element) {
  if (null == element.gwdActivate || "function" == typeof element.gwdActivate) {
    if (null == element.gwdIsActive || !element.gwdIsActive()) {
      var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsActive = wrapperPage && null != wrapperPage.gwdIsActive && "function" == typeof wrapperPage.gwdIsActive;
      null == wrapperPage && element.gwdActivate();
      wrapperPageImplementsIsActive && wrapperPage.gwdIsActive() && element.gwdActivate();
    }
  }
}, isGwdPage_:function(element) {
  return element.tagName.toLowerCase() == GwdPageConstants.TAG_NAME || element.getAttribute("is") == GwdPageConstants.TAG_NAME;
}, closest:function(element, matcher) {
  if (matcher(element)) {
    return element;
  }
  for (;element && element.nodeType != DomUtil.NodeType.DOCUMENT;) {
    if ((element = element.parentElement) && matcher(element)) {
      return element;
    }
  }
  return null;
}, isAttachedToDom:function(element) {
  return !(element.ownerDocument.compareDocumentPosition(element) & Node.DOCUMENT_POSITION_DISCONNECTED);
}, createElement:function(tagName) {
  return document.createElement(tagName);
}, ancestors:function(child) {
  for (var ancestors = [], node = child;node;node = node.parentNode) {
    ancestors.unshift(node);
  }
  return ancestors;
}, commonAncestor:function(node1, node2) {
  for (var ancestors1 = DomUtil.ancestors(node1), ancestors2 = DomUtil.ancestors(node2), i = 0, a1 = ancestors1[0], a2 = ancestors2[0], commonAncestor = null;a1 && a2 && a1 == a2;) {
    commonAncestor = a1, i++, a1 = ancestors1[i], a2 = ancestors2[i];
  }
  return commonAncestor;
}, reflow:function(element) {
  element.setAttribute(DomUtil.REFLOW_ATTRIBUTE_NAME_, element.offsetWidth);
}, getIntegerAttribute:function(element, name, defaultValue) {
  var value = parseInt(element.getAttribute(name), 10);
  isNaN(value) && (value = defaultValue);
  return value;
}, getFloatAttribute:function(element, name, defaultValue) {
  var value = parseFloat(element.getAttribute(name));
  isFinite(value) || (value = defaultValue);
  return value;
}, getStringAttribute:function(element, name, defaultValue) {
  return element.hasAttribute(name) ? element.getAttribute(name) : defaultValue;
}, getBooleanAttribute:function(element, name, defaultValue) {
  switch(element.getAttribute(name)) {
    case "true":
      return !0;
    case "false":
      return !1;
    default:
      return defaultValue;
  }
}, setAttributeIfDifferent:function(element, name, value) {
  return value != element.getAttribute(name) ? (element.setAttribute(name, value), !0) : !1;
}, copyAttribute:function(sourceEl, sourceName, destEl, opt_destName) {
  opt_destName = opt_destName || sourceName;
  if (sourceEl.hasAttribute(sourceName)) {
    var value = sourceEl.getAttribute(sourceName);
    destEl.setAttribute(opt_destName, value);
  } else {
    destEl.removeAttribute(opt_destName);
  }
}};
var GWDCustomElementConstants = {nullFunction:null};
var GwdDoubleClickConstants = {EVENT_DETAIL_URL:"url", EXPANDED_PAGE:"data-gwd-expanded", FULLSCREEN_CLASS_NAME:"fs", GWD_DATABINDER:"gwd-data-binder", GWD_YOUTUBE:"gwd-youtube", HANDLED:"handled", HTML_AUDIO:"audio", HTML_VIDEO:"video", START_PAGE_TRANSITION_DELAY:30, TAG_NAME:"gwd-doubleclick", Attributes:{DATA_PROVIDER:"data-provider", FULLSCREEN:"fullscreen", POLITE_LOAD:"polite-load"}, Events:{AD_INITIALIZED:"adinitialized", COLLAPSE_FINISH:"collapsefinish", COLLAPSE_START:"collapsestart", EXPAND_FINISH:"expandfinish", 
EXPAND_START:"expandstart", FULLSCREEN_SUPPORT:"fullscreensupport"}};
var GwdPageDeckConstants = {TAG_NAME:"gwd-pagedeck", EXTENDS_TAG_NAME:"div", Attributes:{TRANSITION_CLASS:"transition-class", DEFAULT_PAGE:"default-page"}, Events:{BEFORE_PAGES_DETACHED:"beforepagesdetached", PAGE_TRANSITION_START:"pagetransitionstart", PAGE_TRANSITION_END:"pagetransitionend"}};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var BrowserUtil = {Orientation:{PORTRAIT:1, LANDSCAPE:2}, getUserAgentString_:function() {
  return window.navigator.userAgent || "";
}, isWebKit:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("WebKit");
}, isAndroid:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("Android");
}, isFirefox:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 != userAgent.indexOf("rv:") && -1 != userAgent.indexOf("Gecko");
}, isIE:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 < userAgent.indexOf("Trident") || -1 < userAgent.indexOf("MSIE");
}, isGwdDoubleClick_:function(element) {
  return element.tagName.toLowerCase() == GwdDoubleClickConstants.TAG_NAME;
}, openUrl:function(url) {
  window.open(url);
}, getOrientation:function() {
  return BrowserUtil.isPortrait_() ? BrowserUtil.Orientation.PORTRAIT : BrowserUtil.Orientation.LANDSCAPE;
}, isPortrait_:function() {
  return window.innerHeight >= window.innerWidth;
}, getQueryString:function() {
  return window.location.search;
}, setQueryString:function(queryString) {
  window.location.search = queryString;
}};
function MetricConfiguration() {
  this.sourceToMetricEventMap_ = {};
}
MetricConfiguration.prototype.add = function(sourceIdentifier, metricEvent) {
  var sourceIdStr = "string" == typeof sourceIdentifier ? sourceIdentifier : sourceIdentifier.getString();
  this.sourceToMetricEventMap_[sourceIdStr] || (this.sourceToMetricEventMap_[sourceIdStr] = []);
  this.sourceToMetricEventMap_[sourceIdStr].push(metricEvent);
};
MetricConfiguration.prototype.getMetricEventSources = function() {
  var sources = [], useGwdId = "object" == typeof gwd && "GwdId" in gwd, sourceIdStr;
  for (sourceIdStr in this.sourceToMetricEventMap_) {
    sources.push(useGwdId ? new gwd.GwdId(sourceIdStr) : sourceIdStr);
  }
  return sources;
};
MetricConfiguration.prototype.getMetricEventsForSource = function(opt_sourceIdentifier) {
  if (!opt_sourceIdentifier) {
    return [];
  }
  var sourceIdStr = "string" == typeof opt_sourceIdentifier ? opt_sourceIdentifier : opt_sourceIdentifier.getString();
  return this.sourceToMetricEventMap_[sourceIdStr] || [];
};
MetricConfiguration.prototype.getMetricEventForSourceAndEvent = function(opt_sourceIdentifier, opt_eventName) {
  for (var configArray = this.getMetricEventsForSource(opt_sourceIdentifier), i = 0;i < configArray.length;i++) {
    if (configArray[i].event == opt_eventName) {
      return configArray[i];
    }
  }
};
function MetricEventObserver(metricConfiguration, callback) {
  this.metricConfiguration_ = metricConfiguration;
  this.callback_ = callback;
  this.metricEventHandler_ = this.handleMetricEvent_.bind(this);
}
MetricEventObserver.GWD_METRIC_EVENTS_ = "data-gwd-metric-events";
MetricEventObserver.prototype.observe = function(node) {
  if (node.nodeType == Node.ELEMENT_NODE) {
    for (var eventSources = this.metricConfiguration_.getMetricEventSources(), i = 0;i < eventSources.length;i++) {
      var element = this.getElement_(eventSources[i]);
      if (element && DomUtil.contains(node, element)) {
        var metricEvents = this.metricConfiguration_.getMetricEventsForSource(eventSources[i]);
        metricEvents && metricEvents.forEach(function(metricEvent) {
          element.addEventListener(metricEvent.event, this.metricEventHandler_, !1);
        }.bind(this));
      }
    }
  }
};
MetricEventObserver.prototype.forget = function(node) {
  if (node.nodeType == Node.ELEMENT_NODE) {
    for (var eventSources = this.metricConfiguration_.getMetricEventSources(), i = 0;i < eventSources.length;i++) {
      var element = this.getElement_(eventSources[i]);
      if (element && DomUtil.contains(node, element)) {
        var metricEvents = this.metricConfiguration_.getMetricEventsForSource(eventSources[i]);
        metricEvents && metricEvents.forEach(function(metricEvent) {
          element.removeEventListener(metricEvent.event, this.metricEventHandler_, !1);
        }.bind(this));
      }
    }
  }
};
MetricEventObserver.prototype.handleMetricEvent_ = function(event) {
  this.callback_(event);
};
MetricEventObserver.prototype.getElement_ = function(sourceIdentifier) {
  return "string" == typeof sourceIdentifier ? document.getElementById(sourceIdentifier) : sourceIdentifier.getElement(document);
};
var GwdMetricEventConstants = {TAG_NAME:"gwd-metric-event", Attributes:{CUMULATIVE:"cumulative", EVENT:"event", EXIT:"exit", METRIC:"metric", SOURCE:"source"}};
document.registerElement(GwdMetricEventConstants.TAG_NAME);
var GwdMetricConfigurationConstants = {TAG_NAME:"gwd-metric-configuration"};
document.registerElement(GwdMetricConfigurationConstants.TAG_NAME);
var GwdExitConstants = {TAG_NAME:"gwd-exit", Attributes:{ID:"id", METRIC:"metric", URL:"url"}};
document.registerElement(GwdExitConstants.TAG_NAME);
var GwdTimerConstants = {TAG_NAME:"gwd-timer", Attributes:{ID:"id", NAME:"name"}};
document.registerElement(GwdTimerConstants.TAG_NAME);
var GwdDoubleClickElementImpl = function() {
};
goog.inherits(GwdDoubleClickElementImpl, HTMLElement);
GwdDoubleClickElementImpl.prototype.createdCallback = function() {
  document.body.style.opacity = "0";
  this.enablerInitHandler_ = this.handleEnablerInit_.bind(this);
  this.enablerVisibleHandler_ = this.handleEnablerVisible_.bind(this);
  this.enablerPageLoadedHandler_ = this.handleEnablerPageLoaded_.bind(this);
  this.enablerExpandStartHandler_ = this.handleEnablerExpandStart_.bind(this);
  this.enablerCollapseStartHandler_ = this.handleEnablerCollapseStart_.bind(this);
  this.expandFinishHandler_ = EventUtil.dispatch.bind(null, GwdDoubleClickConstants.Events.EXPAND_FINISH, this);
  this.collapseFinishHandler_ = EventUtil.dispatch.bind(null, GwdDoubleClickConstants.Events.COLLAPSE_FINISH, this);
  this.metricEventHandler_ = this.handleMetricEvent_.bind(this);
  this.pageTransitionEndHandler_ = this.handlePageTransitionEnd_.bind(this);
  this.resizeHandler_ = this.handleResize_.bind(this);
  this.isCollapsing_ = this.isExpanding_ = !1;
  this.registeredVideoIdentifiers_ = [];
  this.isAdInitialized_ = !1;
  this.shouldExpandFullscreen_ = this.hasAttribute(GwdDoubleClickConstants.Attributes.FULLSCREEN);
  this.canExpandFullscreen_ = null;
  this.isExpandedFullscreen_ = !1;
  this.orientation_ = BrowserUtil.getOrientation();
  this.dataProvider_ = null;
};
GwdDoubleClickElementImpl.prototype.attachedCallback = function() {
  Enabler.addEventListener(studio.events.StudioEvent.EXPAND_START, this.enablerExpandStartHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.COLLAPSE_START, this.enablerCollapseStartHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.FULLSCREEN_EXPAND_START, this.enablerExpandStartHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.FULLSCREEN_COLLAPSE_START, this.enablerCollapseStartHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.EXPAND_FINISH, this.expandFinishHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.COLLAPSE_FINISH, this.collapseFinishHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.FULLSCREEN_EXPAND_FINISH, this.expandFinishHandler_);
  Enabler.addEventListener(studio.events.StudioEvent.FULLSCREEN_COLLAPSE_FINISH, this.collapseFinishHandler_);
  this.pageDeck_ = this.querySelector("[is=gwd-pagedeck]");
  this.pageDeck_.addEventListener(GwdPageDeckConstants.Events.PAGE_TRANSITION_END, this.pageTransitionEndHandler_, !1);
  this.dataProvider_ = document.getElementById(this.getAttribute(GwdDoubleClickConstants.Attributes.DATA_PROVIDER));
  this.metricConfiguration_ = this.getMetricConfiguration_();
  this.metricEventObserver_ = new MetricEventObserver(this.metricConfiguration_, this.metricEventHandler_);
  window.addEventListener(EventTypes.RESIZE, this.resizeHandler_, !1);
};
GwdDoubleClickElementImpl.prototype.detachedCallback = function() {
  Enabler.removeEventListener(studio.events.StudioEvent.INIT, this.enablerInitHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.VISIBLE, this.enablerVisibleHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.PAGE_LOADED, this.enablerPageLoadedHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.EXPAND_START, this.enablerExpandStartHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.COLLAPSE_START, this.enablerCollapseStartHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.FULLSCREEN_EXPAND_START, this.enablerExpandStartHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.FULLSCREEN_COLLAPSE_START, this.enablerCollapseStartHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.EXPAND_FINISH, this.expandFinishHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.COLLAPSE_FINISH, this.collapseFinishHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.FULLSCREEN_EXPAND_FINISH, this.expandFinishHandler_);
  Enabler.removeEventListener(studio.events.StudioEvent.FULLSCREEN_COLLAPSE_FINISH, this.collapseFinishHandler_);
  this.pageDeck_.removeEventListener(GwdPageDeckConstants.Events.PAGE_TRANSITION_END, this.pageTransitionEndHandler_, !1);
  window.removeEventListener(EventTypes.RESIZE, this.resizeHandler_, !1);
};
GwdDoubleClickElementImpl.prototype.initAd = function() {
  this.isAdInitialized_ = !1;
  this.onEnablerInit_(this.enablerInitHandler_);
};
GwdDoubleClickElementImpl.prototype.exit = function(exitId, url, opt_collapseOnExit, opt_pauseMedia) {
  Enabler.exit(exitId, url);
  ("undefined" == typeof opt_pauseMedia || opt_pauseMedia) && this.pauseMedia_();
  opt_collapseOnExit && this.goToPage();
};
GwdDoubleClickElementImpl.prototype.exitOverride = function(exitId, url, opt_collapseOnExit, opt_pauseMedia) {
  Enabler.exitOverride(exitId, url);
  ("undefined" == typeof opt_pauseMedia || opt_pauseMedia) && this.pauseMedia_();
  opt_collapseOnExit && this.goToPage();
};
GwdDoubleClickElementImpl.prototype.incrementCounter = function(metric, opt_isCumulative) {
  Enabler.counter(metric, opt_isCumulative);
};
GwdDoubleClickElementImpl.prototype.startTimer = function(timerId) {
  Enabler.startTimer(timerId);
};
GwdDoubleClickElementImpl.prototype.stopTimer = function(timerId) {
  Enabler.stopTimer(timerId);
};
GwdDoubleClickElementImpl.prototype.reportManualClose = function() {
  Enabler.reportManualClose();
};
GwdDoubleClickElementImpl.prototype.getMetricConfiguration_ = function() {
  var metricsEl = this.querySelector(GwdMetricConfigurationConstants.TAG_NAME), metricConfiguration = new MetricConfiguration;
  if (metricsEl) {
    for (var metrics = Array.prototype.slice.call(metricsEl.getElementsByTagName(GwdMetricEventConstants.TAG_NAME)), i = 0;i < metrics.length;i++) {
      var metricEl = metrics[i], sourceId = metricEl.getAttribute(GwdMetricEventConstants.Attributes.SOURCE);
      if (sourceId) {
        var exit = metricEl.getAttribute(GwdMetricEventConstants.Attributes.EXIT), metricEvent = {event:metricEl.getAttribute(GwdMetricEventConstants.Attributes.EVENT), metric:metricEl.getAttribute(GwdMetricEventConstants.Attributes.METRIC) || exit, cumulative:metricEl.hasAttribute(GwdMetricEventConstants.Attributes.CUMULATIVE), exit:exit};
        metricConfiguration.add(this.getIdentifier_(sourceId), metricEvent);
      }
    }
  }
  return metricConfiguration;
};
GwdDoubleClickElementImpl.prototype.handleMetricEvent_ = function(event) {
  var target = event.target, targetIdentifier = this.getIdentifier_(target), eventName = targetIdentifier + ": " + event.type, metricEvent = this.metricConfiguration_.getMetricEventForSourceAndEvent(targetIdentifier, event.type);
  if (metricEvent.exit && event.detail && event.detail[GwdDoubleClickConstants.EVENT_DETAIL_URL]) {
    Enabler.exitOverride(targetIdentifier + ": " + metricEvent.exit, event.detail[GwdDoubleClickConstants.EVENT_DETAIL_URL]), event.detail[GwdDoubleClickConstants.HANDLED] = !0, event.detail.collapse && this.goToPage();
  } else {
    var wrapperPage = DomUtil.closest(target, DomUtil.isGwdPage_);
    wrapperPage && wrapperPage.gwdIsActive() && this.incrementCounter(metricEvent.metric || eventName, metricEvent.cumulative);
  }
};
GwdDoubleClickElementImpl.prototype.onEnablerInit_ = function(handler) {
  Enabler.removeEventListener(studio.events.StudioEvent.INIT, handler);
  Enabler.addEventListener(studio.events.StudioEvent.INIT, handler);
  Enabler.isInitialized() && handler();
};
GwdDoubleClickElementImpl.prototype.handleEnablerInit_ = function() {
  var politeLoad = this.hasAttribute(GwdDoubleClickConstants.Attributes.POLITE_LOAD);
  if (politeLoad) {
    this.onEnablerPageLoaded_(this.enablerPageLoadedHandler_);
  } else {
    this.onEnablerVisible_(this.enablerVisibleHandler_);
  }
};
GwdDoubleClickElementImpl.prototype.onEnablerVisible_ = function(handler) {
  Enabler.isVisible() ? handler() : Enabler.addEventListener(studio.events.StudioEvent.VISIBLE, handler);
};
GwdDoubleClickElementImpl.prototype.handleEnablerVisible_ = function(opt_event) {
  if (this.isAdInitialized_) {
    this.isDynamicAd_() && this.bindDynamicData_();
  } else {
    var detail;
    opt_event && (detail = opt_event.detail);
    var renderAd = this.renderAd_.bind(this, detail);
    this.isDynamicAd_() ? this.handleDynamicData_(renderAd) : renderAd();
  }
};
GwdDoubleClickElementImpl.prototype.onEnablerPageLoaded_ = function(handler) {
  Enabler.isPageLoaded() ? handler() : Enabler.addEventListener(studio.events.StudioEvent.PAGE_LOADED, handler);
};
GwdDoubleClickElementImpl.prototype.handleEnablerPageLoaded_ = function() {
  this.onEnablerVisible_(this.enablerVisibleHandler_);
};
GwdDoubleClickElementImpl.prototype.isDynamicAd_ = function() {
  return !!this.dataProvider_;
};
GwdDoubleClickElementImpl.prototype.handleDynamicData_ = function(handler) {
  if (this.dataProvider_) {
    var data = this.dataProvider_.getData(), dataReadyHandler = this.onDynamicDataReady_.bind(this, handler);
    data ? dataReadyHandler() : handler();
    this.dataProvider_.addEventListener(EventTypes.READY, dataReadyHandler);
  } else {
    handler();
  }
};
GwdDoubleClickElementImpl.prototype.onDynamicDataReady_ = function(handler) {
  this.bindDynamicData_();
  handler();
};
GwdDoubleClickElementImpl.prototype.bindDynamicData_ = function() {
  var binders = document.getElementsByTagName(GwdDoubleClickConstants.GWD_DATABINDER);
  if (0 < binders.length) {
    var dataBinder = binders[0], data = this.dataProvider_.getData(), elements = this.pageDeck_.getElementsBySelector("*"), elements = elements.concat(this.pageDeck_.getPages());
    dataBinder.bindData(data, elements);
  }
};
GwdDoubleClickElementImpl.prototype.renderAd_ = function(detail) {
  this.isAdInitialized_ || (this.isAdInitialized_ = !0, document.body.style.opacity = "", EventUtil.dispatch(GwdDoubleClickConstants.Events.AD_INITIALIZED, this, detail), this.goToPage());
};
GwdDoubleClickElementImpl.prototype.goToPage = function(opt_pageId, opt_transition, opt_duration, opt_easing, opt_direction) {
  var currentPage = this.pageDeck_.getPage(this.pageDeck_.currentIndex), nextPage;
  if (nextPage = opt_pageId ? this.pageDeck_.getPage(opt_pageId) : this.pageDeck_.getDefaultPage()) {
    this.nextPageId_ = nextPage.id, opt_transition && (this.pageTransitionOptions_ = {transition:opt_transition, duration:opt_duration, easing:opt_easing, direction:opt_direction}), currentPage && nextPage && this.shouldExpand_(currentPage, nextPage) ? this.expand_() : currentPage && nextPage && this.shouldCollapse_(currentPage, nextPage) ? this.isExpandedFullscreen_ ? Enabler.requestFullscreenCollapse() : Enabler.requestCollapse() : (this.isCollapsing_ = this.isExpanding_ = !1, this.goToNextPage_())
    ;
  }
};
GwdDoubleClickElementImpl.prototype.expand_ = function() {
  if (this.shouldExpandFullscreen_ && !1 !== this.canExpandFullscreen_) {
    if (this.canExpandFullscreen_) {
      this.isExpandedFullscreen_ = !0, Enabler.requestFullscreenExpand();
    } else {
      var supportCallback = function(e) {
        (this.canExpandFullscreen_ = !!e.supported) && EventUtil.dispatch(GwdDoubleClickConstants.Events.FULLSCREEN_SUPPORT, this);
        this.expand_();
        Enabler.removeEventListener(studio.events.StudioEvent.FULLSCREEN_SUPPORT, supportCallback);
      }.bind(this);
      Enabler.addEventListener(studio.events.StudioEvent.FULLSCREEN_SUPPORT, supportCallback);
      Enabler.queryFullscreenSupport();
    }
  } else {
    Enabler.requestExpand();
  }
};
GwdDoubleClickElementImpl.prototype.shouldExpand_ = function(currentPage, nextPage) {
  return !this.isExpanding_ && !currentPage.hasAttribute(GwdPageConstants.Attributes.EXPANDED) && nextPage.hasAttribute(GwdPageConstants.Attributes.EXPANDED);
};
GwdDoubleClickElementImpl.prototype.shouldCollapse_ = function(currentPage, nextPage) {
  return !this.isCollapsing_ && currentPage.hasAttribute(GwdPageConstants.Attributes.EXPANDED) && !nextPage.hasAttribute(GwdPageConstants.Attributes.EXPANDED);
};
GwdDoubleClickElementImpl.prototype.handleEnablerExpandStart_ = function() {
  EventUtil.dispatch(GwdDoubleClickConstants.Events.EXPAND_START, this);
  this.isExpanding_ = !0;
  this.isExpandedFullscreen_ ? Enabler.finishFullscreenExpand() : Enabler.finishExpand();
  ClockUtil.setTimeout(this.goToNextPage_.bind(this), GwdDoubleClickConstants.START_PAGE_TRANSITION_DELAY);
};
GwdDoubleClickElementImpl.prototype.handleEnablerCollapseStart_ = function() {
  EventUtil.dispatch(GwdDoubleClickConstants.Events.COLLAPSE_START, this);
  this.isCollapsing_ = !0;
  this.isExpandedFullscreen_ ? (Enabler.finishFullscreenCollapse(), this.isExpandedFullscreen_ = !1) : Enabler.finishCollapse();
  this.nextPageId_ || (this.reportManualClose(), this.nextPageId_ = this.pageDeck_.getDefaultPage().id);
  ClockUtil.setTimeout(this.goToNextPage_.bind(this), GwdDoubleClickConstants.START_PAGE_TRANSITION_DELAY);
};
GwdDoubleClickElementImpl.prototype.handleResize_ = function() {
  if (!this.nextPageId_) {
    var newOrientation = BrowserUtil.getOrientation();
    if (this.orientation_ != newOrientation) {
      this.orientation_ = newOrientation;
      var currentPage = this.pageDeck_.getPage(this.pageDeck_.currentIndex);
      currentPage && this.goToPage(currentPage.id);
    }
  }
};
GwdDoubleClickElementImpl.prototype.goToNextPage_ = function() {
  if (this.nextPageId_) {
    this.orientation_ = BrowserUtil.getOrientation();
    var nextPage = this.pageDeck_.getOrientationSpecificPage(this.orientation_, this.nextPageId_);
    this.pageTransitionOptions_ ? this.pageDeck_.goToPage(nextPage.id, this.pageTransitionOptions_.transition, this.pageTransitionOptions_.duration, this.pageTransitionOptions_.easing, this.pageTransitionOptions_.direction) : this.pageDeck_.goToPage(nextPage.id);
    this.isExpandedFullscreen_ && nextPage.classList.add(GwdDoubleClickConstants.FULLSCREEN_CLASS_NAME);
  }
  this.pageTransitionOptions_ = this.nextPageId_ = void 0;
};
GwdDoubleClickElementImpl.prototype.handlePageTransitionEnd_ = function(event) {
  this.isCollapsing_ = this.isExpanding_ = !1;
  if (event.target == this.pageDeck_) {
    var eventDetail = event.detail, outgoingPage = eventDetail.outgoingPage, incomingPage = eventDetail.incomingPage;
    outgoingPage && this.handlePageUnbound_(outgoingPage);
    this.handlePageBound_(incomingPage);
  }
};
GwdDoubleClickElementImpl.prototype.handlePageBound_ = function(page) {
  this.metricEventObserver_.observe(page);
  var videoElements = page.querySelectorAll(GwdDoubleClickConstants.HTML_VIDEO);
  if (videoElements && 0 < videoElements.length) {
    var isVideoModuleLoaded = studio.video && studio.video.Reporter, registerVideoElements = this.registerVideoElements_.bind(this);
    this.videosPendingRegistration_ = Array.prototype.slice.call(videoElements);
    isVideoModuleLoaded ? registerVideoElements() : Enabler.loadModule(studio.module.ModuleId.VIDEO, registerVideoElements);
  }
};
GwdDoubleClickElementImpl.prototype.handlePageUnbound_ = function(page) {
  this.metricEventObserver_.forget(page);
  var videoElements = page.querySelectorAll(GwdDoubleClickConstants.HTML_VIDEO);
  videoElements && 0 < videoElements.length && this.unregisterVideoElements_();
};
GwdDoubleClickElementImpl.prototype.registerVideoElements_ = function() {
  for (var identifier, video;this.videosPendingRegistration_.length;) {
    if (video = this.videosPendingRegistration_.shift(), identifier = this.getIdentifier_(video)) {
      studio.video.Reporter.attach(identifier, video, video.autoplay), this.registeredVideoIdentifiers_.push(identifier);
    }
  }
};
GwdDoubleClickElementImpl.prototype.unregisterVideoElements_ = function() {
  for (this.videosPendingRegistration_ = [];this.registeredVideoIdentifiers_.length;) {
    studio.video.Reporter.detach(this.registeredVideoIdentifiers_.shift());
  }
};
GwdDoubleClickElementImpl.prototype.isGwdIdLoaded_ = function() {
  return "object" == typeof gwd && "GwdId" in gwd;
};
GwdDoubleClickElementImpl.prototype.getIdentifier_ = function(elemOrId) {
  return this.isGwdIdLoaded_() ? (new gwd.GwdId(elemOrId)).getString() : "string" == typeof elemOrId ? elemOrId : elemOrId.id;
};
GwdDoubleClickElementImpl.prototype.pauseMedia_ = function() {
  var selector = GwdDoubleClickConstants.HTML_VIDEO + ", " + GwdDoubleClickConstants.GWD_YOUTUBE + ", " + GwdDoubleClickConstants.HTML_AUDIO, mediaElements = Array.prototype.slice.call(this.pageDeck_.querySelectorAll(selector));
  mediaElements.forEach(function(media) {
    media.pause();
  });
};
GwdDoubleClickElementImpl.prototype.attributeChangedCallback = GWDCustomElementConstants.nullFunction;
document.registerElement(GwdDoubleClickConstants.TAG_NAME, {prototype:GwdDoubleClickElementImpl.prototype});

})();
