(function(){
"use strict";
var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var DebugUtil = {assert:function(condition, opt_message) {
  if (!condition) {
    var error = Error(opt_message || "assertion failed");
    console.error(error);
    throw error;
  }
}, raise:function(error) {
  console.error(error);
  throw error;
}, log:function(var_args) {
  "function" == typeof console.trace ? console.trace.apply(console, arguments) : console.log.apply(console, arguments);
}, error:function(var_args) {
  console.error.apply(console, arguments);
}};
var GwdGalleryNavigationConstants = {BUTTON_FRAME_NUM_PROPERTY:"gwdTargetFrameNum", GRAY_PLACEHOLDER_THUMBNAIL_GIF:"data:image/gif;base64,R0lGODlhAQABAPAAAGZmZgAAACH5BAAAAAAALAAAAAABAAEAAAICRAEAOw==", TAG_NAME:"gwd-gallerynavigation", GROUP_REFERENCE_ATTR:"data-gwd-group", GROUP_ID_ATTR:"data-gwd-grp-id", Attributes:{FOR:"for", HIGHLIGHT:"highlight", USE_THUMBNAILS:"use-thumbnails"}, StyleClasses:{ACTIVE:"active", BUTTON:"button", BUTTON_CONTAINER:"button-container", FRAME_DOT:"frame-dot", FRAME_THUMBNAIL:"frame-thumbnail"}};
var GWDGalleryConstants = {Animate:{NONE:"none", SLIDE:"slide"}, Direction:{BACKWARDS:"backwards", FORWARDS:"forwards", LEFT:"left", RIGHT:"right"}, Events:{ALL_FRAMES_LOADED:"allframesloaded", ALL_FRAMES_VIEWED:"allframesviewed", AUTOPLAY_ENDED:"autoplayended", FIRST_INTERACTION:"firstinteraction", FRAME_ACTIVATED:"frameactivated", FRAME_AUTOPLAYED:"frameautoplayed", FRAME_EXIT:"frameexit", FRAME_SHOWN:"frameshown", FRAME_TAP:"frametap", REACH_LEFT_END:"reachleftend", FRAME_MOUSE_OVER:"framemouseover", 
FRAME_MOUSE_OUT:"framemouseout", REACH_RIGHT_END:"reachrightend"}, Attributes:{AUTOPLAY:"autoplay", AUTOPLAY_DURATION:"autoplay-duration", AUTOPLAY_STEP_DURATION:"autoplay-step-duration", FRAME_HEIGHT:"frame-height", FRAME_WIDTH:"frame-width", HAS_NAVIGATION:"has-navigation", IMAGES:"images", NAVIGATION_HIGHLIGHT:"navigation-highlight", NAVIGATION_THUMBNAILS:"navigation-thumbnails", SCALING:"scaling", START_FRAME:"start-frame", TRANSITION_DURATION:"transition-duration"}};
var CssUtil = {Attributes:{TRANSITION_DURATION:"transition-duration"}, browserPrefixes_:["-ms-", "-moz-", "-webkit-", ""], applyCssWithBrowserPrefix:function(element, name, value, opt_prefixOnValue) {
  for (var propertyName, propertyValue, i = 0;i < CssUtil.browserPrefixes_.length;++i) {
    propertyName = CssUtil.browserPrefixes_[i] + name, propertyValue = (opt_prefixOnValue ? CssUtil.browserPrefixes_[i] : "") + value, element.style.setProperty(propertyName, propertyValue);
  }
}, getPropertyValue:function(element, name) {
  for (var falseyValue = null, value, i = 0;i < CssUtil.browserPrefixes_.length;++i) {
    if (value = element.style.getPropertyValue(CssUtil.browserPrefixes_[i] + name)) {
      return value;
    }
    null != value && (falseyValue = value);
  }
  return falseyValue;
}, installStyles:function(stylesString) {
  var styleSheet = null, doc = document, isIE = -1 != navigator.userAgent.indexOf("MSIE");
  if (isIE && doc.createStyleSheet) {
    styleSheet = doc.createStyleSheet(), styleSheet.cssText = stylesString;
  } else {
    var head = doc.getElementsByTagName("head")[0];
    if (!head) {
      var body = doc.getElementsByTagName("body")[0], head = doc.createElement("head");
      body.parentNode.insertBefore(head, body);
    }
    styleSheet = doc.createElement("style");
    styleSheet.innerHTML = stylesString;
    head.appendChild(styleSheet);
  }
  return styleSheet;
}, uninstallStyles:function(styleSheet) {
  var node = styleSheet.ownerNode || styleSheet.owningElement || styleSheet;
  node && node.parentNode && node.parentNode.removeChild(node);
}, isElementShown:function(el) {
  return "none" != el.style.display;
}, setElementShown:function(el, isShown) {
  el.style.display = isShown ? "" : "none";
}};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var FileUtil = {getFullPath:function(src) {
  src = src.trim();
  return window.Enabler ? Enabler.getUrl(src) : src;
}};
var GwdGestureConstants = {TAP_THRESHOLD:10, TAG_NAME:"gwd-gesture", DEFAULT_SWIPE_VELOCITY:.5, DEFAULT_SWIPE_DISTANCE:.1, TouchAction:{NONE:"none", AUTO:"auto", PAN_X:"pan-x", PAN_Y:"pan-y"}, Attributes:{TOUCH_ACTION:"touch-action", SWIPE_VELOCITY:"swipe-velocity", SWIPE_DISTANCE:"swipe-distance"}};
var GwdImageConstants = {NONE_SCALING_BACKGROUND_SIZE_:"auto", TAG_NAME:"gwd-image", BLANK_TRANSPARENT_GIF:"data:image/gif;base64,R0lGODlhAQABAPAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==", EXTENDS_TAG_NAME:"img", Attributes:{SCALING:"scaling", SOURCE:"source", SRC:"src"}, States:{INIT:0, PENDING:1, LOADED:2, ERROR:3}, ScalingModes:{CONTAIN:"contain", COVER:"cover", NONE:"none", STRETCH:"stretch"}};
GwdImageConstants.Defaults = {SCALING:GwdImageConstants.ScalingModes.STRETCH};
GwdImageConstants.StyleClasses = {SCALED_PROPORTIONALLY:"scaled-proportionally"};
var GalleryUtil = {FRAME_CLASS_NAME_:"frame", GESTURE_CLASS_NAME_:"gesture", Autoplayer:function(gallery, delayFirst) {
  this.gallery_ = gallery;
  this.playIntervalId_ = null;
  this.playCurrentFirst_ = delayFirst;
  this.goingToFrame_ = !1;
}};
GalleryUtil.Autoplayer.prototype.play = function(duration, opt_direction, opt_stepInterval) {
  if (this.gallery_.frameCount && !this.isPlaying()) {
    var direction = opt_direction || GWDGalleryConstants.Direction.FORWARDS;
    DebugUtil.assert(direction == GWDGalleryConstants.Direction.FORWARDS || direction == GWDGalleryConstants.Direction.BACKWARDS, "Unexpected rotation direction: " + direction);
    var stepCount, stepInterval;
    opt_stepInterval ? (stepCount = Math.floor(duration / opt_stepInterval), stepInterval = opt_stepInterval) : (stepCount = this.gallery_.frameCount, stepInterval = duration / stepCount);
    for (var targetIndices = [], baseFrameIndex = this.gallery_.currentIndex - 1, nextIndex = baseFrameIndex, i = 0;i < stepCount;i++) {
      if (0 < i || !this.playCurrentFirst_) {
        nextIndex = GalleryUtil.getNextFrame(nextIndex, direction, this.gallery_.frameCount);
      }
      targetIndices.push(nextIndex);
    }
    var stepOneFrame = function() {
      if (targetIndices.length) {
        var targetIndex = targetIndices.shift();
        this.goToFrame_(targetIndex + 1);
        GalleryUtil.dispatchEventWithIndex(this.gallery_, GWDGalleryConstants.Events.FRAME_AUTOPLAYED, targetIndex + 1);
      } else {
        this.stop(!0), this.gallery_.goToFrame(baseFrameIndex + 1);
      }
    }.bind(this);
    this.playIntervalId_ = ClockUtil.setInterval(stepOneFrame, stepInterval);
    setTimeout(stepOneFrame);
  }
};
GalleryUtil.Autoplayer.prototype.goToFrame_ = function(frameIndex) {
  DebugUtil.assert(!this.goingToFrame_);
  this.goingToFrame_ = !0;
  this.gallery_.goToFrame(frameIndex);
  DebugUtil.assert(this.goingToFrame_);
  this.goingToFrame_ = !1;
};
GalleryUtil.Autoplayer.prototype.stop = function(opt_completed) {
  !this.goingToFrame_ && this.playIntervalId_ && (ClockUtil.clearInterval(this.playIntervalId_), EventUtil.dispatchAsync(GWDGalleryConstants.Events.AUTOPLAY_ENDED, this.gallery_, {completed:!!opt_completed}), this.playIntervalId_ = null);
};
GalleryUtil.Autoplayer.prototype.isPlaying = function() {
  return null != this.playIntervalId_;
};
GalleryUtil.isGallery = function(element) {
  if (!element) {
    return !1;
  }
  for (var expectedProperties = "currentIndex frameCount frameSnapInterval getFrame goToFrame goForwards goBackwards rotateOnce".split(" "), i = 0;i < expectedProperties.length;++i) {
    if (!(expectedProperties[i] in element)) {
      return !1;
    }
  }
  return !0;
};
GalleryUtil.prepareOneFrame_ = function(imageUrl) {
  var image = document.createElement("img", GwdImageConstants.TAG_NAME);
  image.setAttribute(GwdImageConstants.Attributes.SOURCE, imageUrl);
  return image;
};
GalleryUtil.createFrames = function(imagesString) {
  var frames = [];
  if (imagesString) {
    for (var images = imagesString.split(","), i = 0;i < images.length;++i) {
      /\S/.test(images[i]) && frames.push(GalleryUtil.prepareOneFrame_(FileUtil.getFullPath(images[i])));
    }
  }
  return frames;
};
GalleryUtil.createLoadingPage = function(frames, opt_perFrameOperation) {
  for (var loadingPage = document.createElement("div", GwdPageConstants.TAG_NAME), frame, i = 0;i < frames.length;++i) {
    frame = frames[i], CssUtil.applyCssWithBrowserPrefix(frame, "user-select", "none"), frame.classList.add(GalleryUtil.FRAME_CLASS_NAME_), opt_perFrameOperation && opt_perFrameOperation(frame), loadingPage.appendChild(frame);
  }
  EventUtil.listenOnce(loadingPage, EventTypes.ATTACHED, loadingPage.gwdLoad.bind(loadingPage));
  return loadingPage;
};
GalleryUtil.createGestureElement = function() {
  var gesture = document.createElement(GwdGestureConstants.TAG_NAME);
  gesture.className = GalleryUtil.GESTURE_CLASS_NAME_;
  return gesture;
};
GalleryUtil.extractFrames = function(frameList) {
  for (var frames = [], i = 0, length = frameList.length;i < length;i++) {
    var frame = frameList[i];
    frame.nodeType == Node.ELEMENT_NODE && frames.push(frame);
  }
  return frames;
};
GalleryUtil.applyScaling = function(frames, scaling) {
  for (var i = 0, l = frames.length;i < l;i++) {
    var frame = frames[i];
    "img" == frame.tagName.toLowerCase() && frame.getAttribute("is") == GwdImageConstants.TAG_NAME && (null != scaling ? frame.setAttribute(GwdImageConstants.Attributes.SCALING, scaling) : frame.removeAttribute(GwdImageConstants.Attributes.SCALING));
  }
};
GalleryUtil.dispatchEventWithIndex = function(gallery, eventName, opt_index) {
  var index = opt_index || gallery.currentIndex;
  EventUtil.dispatch(eventName, gallery, {id:index});
};
GalleryUtil.dispatchEventsOnTransitionEnd = function(gallery, events) {
  for (var length = events.length, eventNames = events.splice(0, length), eventName, i = 0;i < length;i++) {
    eventName = eventNames[i], eventName == GWDGalleryConstants.Events.FRAME_SHOWN ? GalleryUtil.dispatchEventWithIndex(gallery, eventName) : EventUtil.dispatch(eventName, gallery);
  }
};
GalleryUtil.getFrameIncrement_ = function(direction, distance) {
  var moveBackwards = direction == GWDGalleryConstants.Direction.LEFT || direction == GWDGalleryConstants.Direction.BACKWARDS;
  return moveBackwards ? -distance : distance;
};
GalleryUtil.findProperFrame = function(index, frameCount) {
  return (index % frameCount + frameCount) % frameCount;
};
GalleryUtil.getNextFrame = function(index, direction, frameCount, opt_distance) {
  var distance = opt_distance || 1;
  return GalleryUtil.findProperFrame(index + GalleryUtil.getFrameIncrement_(direction, distance), frameCount);
};
var GWDGalleryNavigationElementImpl = function() {
};
goog.inherits(GWDGalleryNavigationElementImpl, HTMLElement);
GWDGalleryNavigationElementImpl.prototype.createdCallback = function() {
  this.gallery_ = null;
  this.galleryReadyHandler_ = this.onGalleryReady_.bind(this);
  this.galleryFrameActivatedHandler_ = this.onGalleryFrameActivated_.bind(this);
  this.useThumbnails_ = !1;
  this.buttonContainer_ = document.createElement("div");
  this.buttonContainer_.classList.add(GwdGalleryNavigationConstants.StyleClasses.BUTTON_CONTAINER);
  this.appendChild(this.buttonContainer_);
  this.buttonContainer_.addEventListener(EventTypes.CLICK, this.onButtonContainerClicked_.bind(this), !0);
  this.buttons_ = [];
};
GWDGalleryNavigationElementImpl.prototype.getElementByIdOrPseudoId_ = function(id) {
  for (var element = document.getElementById(id), reachedBody = !1, ancestor = this.parentNode;!element && ancestor && !reachedBody;ancestor = ancestor.parentNode) {
    if ((reachedBody = "body" == ancestor.tagName.toLowerCase()) || ancestor.hasAttribute(GwdGalleryNavigationConstants.GROUP_REFERENCE_ATTR)) {
      element = ancestor.querySelector("[" + GwdGalleryNavigationConstants.GROUP_ID_ATTR + '="' + id + '"]');
    }
  }
  return element;
};
GWDGalleryNavigationElementImpl.prototype.updateBinding_ = function() {
  this.clearGalleryHandlers_();
  var id = this.getAttribute(GwdGalleryNavigationConstants.Attributes.FOR), gallery = null;
  id && (gallery = this.getElementByIdOrPseudoId_(id));
  GalleryUtil.isGallery(gallery) && (this.gallery_ = gallery, gallery.addEventListener(GWDGalleryConstants.Events.FRAME_ACTIVATED, this.galleryFrameActivatedHandler_), gallery.gwdIsLoaded() ? this.updateButtons_() : gallery.addEventListener(EventTypes.READY, this.galleryReadyHandler_));
};
GWDGalleryNavigationElementImpl.prototype.clearGalleryHandlers_ = function() {
  this.gallery_ && (this.gallery_.removeEventListener(EventTypes.READY, this.galleryReadyHandler_), this.gallery_.removeEventListener(GWDGalleryConstants.Events.FRAME_ACTIVATED, this.galleryFrameActivatedHandler_));
};
GWDGalleryNavigationElementImpl.prototype.onGalleryReady_ = function(event) {
  event.target == this.gallery_ && this.updateButtons_();
};
GWDGalleryNavigationElementImpl.prototype.onGalleryFrameActivated_ = function(event) {
  event.target == this.gallery_ && this.updateActiveButtons_(event.detail.id);
};
GWDGalleryNavigationElementImpl.prototype.onButtonContainerClicked_ = function(event) {
  for (var target = event.target;target && target != this;target = target.parentNode) {
    if (target[GwdGalleryNavigationConstants.BUTTON_FRAME_NUM_PROPERTY]) {
      this.gallery_.goToFrame(target[GwdGalleryNavigationConstants.BUTTON_FRAME_NUM_PROPERTY]);
      break;
    }
  }
};
GWDGalleryNavigationElementImpl.prototype.updateButtons_ = function() {
  var highlightColor = this.getAttribute(GwdGalleryNavigationConstants.Attributes.HIGHLIGHT);
  this.style.color = highlightColor || "";
  this.useThumbnails_ = this.hasAttribute(GwdGalleryNavigationConstants.Attributes.USE_THUMBNAILS);
  for (this.buttons_ = [];this.buttonContainer_.firstChild;) {
    this.buttonContainer_.removeChild(this.buttonContainer_.firstChild);
  }
  if (this.gallery_) {
    for (var i = 0;i < this.gallery_.frameCount;i += this.gallery_.frameSnapInterval) {
      var button = document.createElement("span");
      button.classList.add(GwdGalleryNavigationConstants.StyleClasses.BUTTON);
      for (var visualsInButton = this.useThumbnails_ ? this.gallery_.frameSnapInterval : 1, j = 0;j < visualsInButton;++j) {
        var galleryFrame = this.gallery_.getFrame(i + j + 1);
        if (!galleryFrame) {
          break;
        }
        var frameVisual = this.createFrameVisual_(galleryFrame);
        button.appendChild(frameVisual);
      }
      button[GwdGalleryNavigationConstants.BUTTON_FRAME_NUM_PROPERTY] = i + 1;
      this.buttons_.push(button);
      this.buttonContainer_.appendChild(button);
    }
    this.updateActiveButtons_();
  }
};
GWDGalleryNavigationElementImpl.prototype.createFrameVisual_ = function(galleryFrame) {
  var visual = document.createElement("span");
  if (this.useThumbnails_) {
    visual.classList.add(GwdGalleryNavigationConstants.StyleClasses.FRAME_THUMBNAIL);
    var frameImage, frameImageSrc;
    (frameImage = "img" == galleryFrame.tagName.toLowerCase() ? galleryFrame : galleryFrame.querySelector("img")) && (frameImageSrc = frameImage.getAttribute(GwdImageConstants.Attributes.SOURCE) || frameImage.getAttribute(GwdImageConstants.Attributes.SRC));
    visual.style.backgroundImage = frameImageSrc ? "url(" + JSON.stringify(frameImageSrc) + ")" : "url(" + GwdGalleryNavigationConstants.GRAY_PLACEHOLDER_THUMBNAIL_GIF + ")";
  } else {
    visual.classList.add(GwdGalleryNavigationConstants.StyleClasses.FRAME_DOT);
  }
  return visual;
};
GWDGalleryNavigationElementImpl.prototype.updateActiveButtons_ = function(opt_activeIndex) {
  var buttonIndex;
  buttonIndex = void 0 != opt_activeIndex ? opt_activeIndex - 1 : this.gallery_.currentIndex - 1;
  buttonIndex = Math.floor(buttonIndex / this.gallery_.frameSnapInterval);
  for (var i = 0;i < this.buttons_.length;i++) {
    this.buttons_[i].classList.remove(GwdGalleryNavigationConstants.StyleClasses.ACTIVE);
  }
  var activeButton = this.buttons_[buttonIndex];
  activeButton && activeButton.classList.add(GwdGalleryNavigationConstants.StyleClasses.ACTIVE);
};
GWDGalleryNavigationElementImpl.prototype.attachedCallback = function() {
  this.updateBinding_();
};
GWDGalleryNavigationElementImpl.prototype.detachedCallback = function() {
  this.clearGalleryHandlers_();
};
GWDGalleryNavigationElementImpl.prototype.attributeChangedCallback = function(attributeName) {
  attributeName == GwdGalleryNavigationConstants.Attributes.FOR ? this.updateBinding_() : this.updateButtons_();
};
document.registerElement(GwdGalleryNavigationConstants.TAG_NAME, {prototype:GWDGalleryNavigationElementImpl.prototype});

})();
