(function(){
"use strict";
var GWDCustomElementConstants = {nullFunction:null};
var GwdGestureConstants = {TAP_THRESHOLD:10, TAG_NAME:"gwd-gesture", DEFAULT_SWIPE_VELOCITY:.5, DEFAULT_SWIPE_DISTANCE:.1, TouchAction:{NONE:"none", AUTO:"auto", PAN_X:"pan-x", PAN_Y:"pan-y"}, Attributes:{TOUCH_ACTION:"touch-action", SWIPE_VELOCITY:"swipe-velocity", SWIPE_DISTANCE:"swipe-distance"}};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var PointerEventGenerator = {};
PointerEventGenerator.Events = {CANCEL:EventTypes.POINTER_CANCEL, DOWN:EventTypes.POINTER_DOWN, MOVE:EventTypes.POINTER_MOVE, OUT:EventTypes.POINTER_OUT, OVER:EventTypes.POINTER_OVER, UP:EventTypes.POINTER_UP};
PointerEventGenerator.MsPointerEvents_ = {CANCEL:"MSPointerCancel", DOWN:"MSPointerDown", MOVE:"MSPointerMove", OUT:"MSPointerOut", OVER:"MSPointerOver", UP:"MSPointerUp"};
PointerEventGenerator.TOUCH_ACTION_ATTRIBUTE_ = "touch-action";
PointerEventGenerator.TOUCH_ACTION_STYLE_NAME_ = "touchAction";
PointerEventGenerator.MS_TOUCH_ACTION_STYLE_NAME_ = "msTouchAction";
PointerEventGenerator.TouchAction = {AUTO:0, NONE:1, PAN_X:2, PAN_Y:3};
PointerEventGenerator.TouchActionAttributes_ = ["auto", "none", "pan-x", "pan-y"];
PointerEventGenerator.MOUSE_POINTER_ID_ = 1;
PointerEventGenerator.INITIAL_TOUCH_POINTER_ID_ = 2;
PointerEventGenerator.nextPointerId_ = PointerEventGenerator.INITIAL_TOUCH_POINTER_ID_;
PointerEventGenerator.primaryTouchId_ = null;
PointerEventGenerator.scrolling_ = !1;
PointerEventGenerator.primaryTouchStartX_ = null;
PointerEventGenerator.primaryTouchStartY_ = null;
PointerEventGenerator.lastTouches_ = [];
PointerEventGenerator.SYNTH_MOUSE_EVENT_TIMEOUT_ = 2500;
PointerEventGenerator.SYNTH_MOUSE_DISTANCE_THRESHOLD_ = 25;
PointerEventGenerator.initialize = function(target, opt_touchAction) {
  var touchAction = opt_touchAction || PointerEventGenerator.TouchAction.AUTO;
  PointerEventGenerator.prepareNative_(target, touchAction);
  PointerEventGenerator.isPointerEnabled_() || (PointerEventGenerator.isMsPointerEnabled_() ? PointerEventGenerator.prepareMsPointer_(target) : (PointerEventGenerator.prepareMouse_(target), PointerEventGenerator.isTouchAvailable_() && PointerEventGenerator.prepareTouch_(target, touchAction)));
};
PointerEventGenerator.prepareNative_ = function(target, action) {
  var touchAction = PointerEventGenerator.TouchActionAttributes_[action];
  target.setAttribute(PointerEventGenerator.TOUCH_ACTION_ATTRIBUTE_, touchAction);
  target.style[PointerEventGenerator.TOUCH_ACTION_STYLE_NAME_] = touchAction;
  target.style[PointerEventGenerator.MS_TOUCH_ACTION_STYLE_NAME_] = touchAction;
};
PointerEventGenerator.prepareMsPointer_ = function(target) {
  target.addEventListener(PointerEventGenerator.MsPointerEvents_.OVER, PointerEventGenerator.triggerEventForMsPointer_.bind(null, target, PointerEventGenerator.Events.OVER), !1);
  target.addEventListener(PointerEventGenerator.MsPointerEvents_.DOWN, PointerEventGenerator.triggerEventForMsPointer_.bind(null, target, PointerEventGenerator.Events.DOWN), !1);
  target.addEventListener(PointerEventGenerator.MsPointerEvents_.MOVE, PointerEventGenerator.triggerEventForMsPointer_.bind(null, target, PointerEventGenerator.Events.MOVE), !1);
  target.addEventListener(PointerEventGenerator.MsPointerEvents_.UP, PointerEventGenerator.triggerEventForMsPointer_.bind(null, target, PointerEventGenerator.Events.UP), !1);
  target.addEventListener(PointerEventGenerator.MsPointerEvents_.OUT, PointerEventGenerator.triggerEventForMsPointer_.bind(null, target, PointerEventGenerator.Events.OUT), !1);
  target.addEventListener(PointerEventGenerator.MsPointerEvents_.CANCEL, PointerEventGenerator.triggerEventForMsPointer_.bind(null, target, PointerEventGenerator.Events.CANCEL), !1);
};
PointerEventGenerator.prepareMouse_ = function(target) {
  target.addEventListener(EventTypes.MOUSE_OVER, PointerEventGenerator.triggerEventForMouse_.bind(null, target, PointerEventGenerator.Events.OVER), !1);
  target.addEventListener(EventTypes.MOUSE_DOWN, PointerEventGenerator.triggerEventForMouse_.bind(null, target, PointerEventGenerator.Events.DOWN), !1);
  target.addEventListener(EventTypes.MOUSE_MOVE, PointerEventGenerator.triggerEventForMouse_.bind(null, target, PointerEventGenerator.Events.MOVE), !1);
  target.addEventListener(EventTypes.MOUSE_UP, PointerEventGenerator.triggerEventForMouse_.bind(null, target, PointerEventGenerator.Events.UP), !1);
  target.addEventListener(EventTypes.MOUSE_OUT, PointerEventGenerator.triggerEventForMouse_.bind(null, target, PointerEventGenerator.Events.OUT), !1);
};
PointerEventGenerator.prepareTouch_ = function(target, touchAction) {
  target.addEventListener(EventTypes.TOUCH_START, PointerEventGenerator.onTouchStart_.bind(null, target), !1);
  touchAction != PointerEventGenerator.TouchAction.AUTO && target.addEventListener(EventTypes.TOUCH_MOVE, PointerEventGenerator.onTouchMove_.bind(null, touchAction, target), !1);
  target.addEventListener(EventTypes.TOUCH_END, PointerEventGenerator.onTouchEnd_.bind(null, target), !1);
};
PointerEventGenerator.clearPrimaryTouchId_ = function() {
  PointerEventGenerator.primaryTouchId_ = null;
};
PointerEventGenerator.isPrimaryTouch_ = function(touch) {
  return PointerEventGenerator.primaryTouchId_ == touch.identifier;
};
PointerEventGenerator.onTouchStart_ = function(target, event) {
  PointerEventGenerator.maybeSetPrimaryTouch_(event.changedTouches[0]);
  PointerEventGenerator.dedupMouseEvent_(event);
  PointerEventGenerator.triggerEventForTouch_(target, PointerEventGenerator.Events.OVER, event);
  PointerEventGenerator.triggerEventForTouch_(target, PointerEventGenerator.Events.DOWN, event);
};
PointerEventGenerator.maybeSetPrimaryTouch_ = function(touch) {
  null == PointerEventGenerator.primaryTouchId_ && (PointerEventGenerator.primaryTouchId_ = touch.identifier, PointerEventGenerator.primaryTouchStartX_ = touch.clientX, PointerEventGenerator.primaryTouchStartY_ = touch.clientY, PointerEventGenerator.scrolling_ = !1);
};
PointerEventGenerator.onTouchMove_ = function(action, target, event) {
  PointerEventGenerator.scrolling_ || (PointerEventGenerator.TouchAction.NONE != action && null != PointerEventGenerator.primaryTouchStartX_ && PointerEventGenerator.shouldScrollOnTouchMove_(action, PointerEventGenerator.primaryTouchStartX_, PointerEventGenerator.primaryTouchStartY_, event) ? (PointerEventGenerator.triggerEventForTouch_(target, PointerEventGenerator.Events.CANCEL, event), PointerEventGenerator.scrolling_ = !0, PointerEventGenerator.clearPrimaryTouchId_()) : (PointerEventGenerator.triggerEventForTouch_(target, 
  PointerEventGenerator.Events.MOVE, event), event.preventDefault()), PointerEventGenerator.primaryTouchStartX_ = null, PointerEventGenerator.primaryTouchStartY_ = null);
};
PointerEventGenerator.shouldScrollOnTouchMove_ = function(action, startX, startY, event) {
  var touchCoords = event.touches[0], xDiff = Math.abs(touchCoords.clientX - startX), yDiff = Math.abs(touchCoords.clientY - startY);
  return action == PointerEventGenerator.TouchAction.PAN_X ? xDiff > yDiff : yDiff > xDiff;
};
PointerEventGenerator.onTouchEnd_ = function(target, event) {
  PointerEventGenerator.scrolling_ || (PointerEventGenerator.dedupMouseEvent_(event), PointerEventGenerator.maybeClearPrimaryTouch_(event), PointerEventGenerator.triggerEventForTouch_(target, PointerEventGenerator.Events.UP, event), PointerEventGenerator.triggerEventForTouch_(target, PointerEventGenerator.Events.OUT, event));
};
PointerEventGenerator.maybeClearPrimaryTouch_ = function(event) {
  null != PointerEventGenerator.primaryTouchId_ && PointerEventGenerator.forEachTouch_(event, function(touch) {
    PointerEventGenerator.isPrimaryTouch_(touch) && (PointerEventGenerator.clearPrimaryTouchId_(), PointerEventGenerator.primaryTouchStartX_ = null, PointerEventGenerator.primaryTouchStartY_ = null);
  });
};
PointerEventGenerator.dedupMouseEvent_ = function(event) {
  var touch = event.changedTouches[0];
  if (PointerEventGenerator.isPrimaryTouch_(touch)) {
    var lastTouch = {cX:touch.clientX, cY:touch.clientY, sX:touch.screenX, sY:touch.screenY};
    PointerEventGenerator.lastTouches_.push(lastTouch);
    setTimeout(function(lastTouch) {
      var i = PointerEventGenerator.lastTouches_.indexOf(lastTouch);
      -1 < i && PointerEventGenerator.lastTouches_.splice(i, 1);
    }.bind(null, lastTouch), PointerEventGenerator.SYNTH_MOUSE_EVENT_TIMEOUT_);
  }
};
PointerEventGenerator.isSyntheticMouseEvent_ = function(event) {
  for (var i = 0;i < PointerEventGenerator.lastTouches_.length;i++) {
    if (PointerEventGenerator.meetsSyntheticMouseEventThreshold_(event.clientX, event.clientY, PointerEventGenerator.lastTouches_[i].cX, PointerEventGenerator.lastTouches_[i].cY) || PointerEventGenerator.meetsSyntheticMouseEventThreshold_(event.screenX, event.screenY, PointerEventGenerator.lastTouches_[i].sX, PointerEventGenerator.lastTouches_[i].sY)) {
      return !0;
    }
  }
  return !1;
};
PointerEventGenerator.meetsSyntheticMouseEventThreshold_ = function(eventX, eventY, x, y) {
  var dx = Math.abs(eventX - x), dy = Math.abs(eventY - y);
  return dx <= PointerEventGenerator.SYNTH_MOUSE_DISTANCE_THRESHOLD_ && dy <= PointerEventGenerator.SYNTH_MOUSE_DISTANCE_THRESHOLD_;
};
PointerEventGenerator.createPointerEvent_ = function(type, pointerId, inPointer, isPrimary) {
  var event = document.createEvent("Event");
  event.initEvent(type, !0, !0);
  event.clientX = inPointer.clientX;
  event.clientY = inPointer.clientY;
  event.pointerId = pointerId;
  event.isPrimary = isPrimary;
  return event;
};
PointerEventGenerator.currentPointers_ = {};
PointerEventGenerator.getPointerEventKey_ = function(touch) {
  return "" + touch.identifier;
};
PointerEventGenerator.createPointerIdFromTouch_ = function(touch) {
  var pointerKey = PointerEventGenerator.getPointerEventKey_(touch);
  PointerEventGenerator.currentPointers_[pointerKey] || (PointerEventGenerator.currentPointers_[pointerKey] = PointerEventGenerator.nextPointerId_++);
  return PointerEventGenerator.currentPointers_[pointerKey];
};
PointerEventGenerator.deletePointerIdForTouch_ = function(touch) {
  delete PointerEventGenerator.currentPointers_[PointerEventGenerator.getPointerEventKey_(touch)];
};
PointerEventGenerator.triggerEventForMouse_ = function(target, eventName, originalEvent) {
  originalEvent.preventDefault();
  PointerEventGenerator.isSyntheticMouseEvent_(originalEvent) || target.dispatchEvent(PointerEventGenerator.createPointerEvent_(eventName, PointerEventGenerator.MOUSE_POINTER_ID_, originalEvent, !0));
};
PointerEventGenerator.triggerEventForMsPointer_ = function(target, eventName, event) {
  target.dispatchEvent(PointerEventGenerator.createPointerEvent_(eventName, event.pointerId, event, event.isPrimary));
};
PointerEventGenerator.triggerEventForTouch_ = function(target, eventName, originalEvent) {
  PointerEventGenerator.forEachTouch_(originalEvent, function(touch) {
    target.dispatchEvent(PointerEventGenerator.createPointerEvent_(eventName, PointerEventGenerator.createPointerIdFromTouch_(touch), touch, PointerEventGenerator.isPrimaryTouch_(touch)));
  });
};
PointerEventGenerator.forEachTouch_ = function(event, operation) {
  for (var touches = event.changedTouches, i = 0, len = touches.length;i < len;++i) {
    operation(touches[i]);
  }
};
PointerEventGenerator.isPointerEnabled_ = function() {
  return navigator.pointerEnabled;
};
PointerEventGenerator.isMsPointerEnabled_ = function() {
  return navigator.msPointerEnabled;
};
PointerEventGenerator.isTouchAvailable_ = function() {
  return void 0 !== window.ontouchstart;
};
var GwdGestureUtil = {getPointerKey:function(event) {
  return "" + event.pointerId;
}, shouldInvalidateTap:function(pointer, event) {
  return Math.abs(pointer.downX - event.clientX) > GwdGestureConstants.TAP_THRESHOLD || Math.abs(pointer.downY - event.clientY) > GwdGestureConstants.TAP_THRESHOLD;
}, createTapEvent:function(event) {
  var tap = document.createEvent("Event");
  tap.initEvent(EventTypes.TAP, !0, !0);
  tap.clientX = event.clientX;
  tap.clientY = event.clientY;
  return tap;
}, createTrackStartEvent:function(pointer) {
  return GwdGestureUtil.instantiateTrackEvent_(EventTypes.TRACK_START, pointer.downX, pointer.downY, 0, 0, 0, 0);
}, createTrackEvent:function(pointer, event) {
  return GwdGestureUtil.createTrackEventFromPointer_(EventTypes.TRACK, pointer, event);
}, createTrackEndEvent:function(pointer, event) {
  return GwdGestureUtil.createTrackEventFromPointer_(EventTypes.TRACK_END, pointer, event);
}, createTrackEventFromPointer_:function(eventName, pointer, event) {
  return GwdGestureUtil.instantiateTrackEvent_(eventName, event.clientX, event.clientY, event.clientX - pointer.downX, event.clientY - pointer.downY, event.clientX - pointer.lastX, event.clientY - pointer.lastY);
}, instantiateTrackEvent_:function(eventName, clientX, clientY, dx, dy, ddx, ddy) {
  var track = document.createEvent("Event");
  track.initEvent(eventName, !0, !0);
  track.clientX = clientX;
  track.clientY = clientY;
  track.dx = dx;
  track.dy = dy;
  track.ddx = ddx;
  track.ddy = ddy;
  return track;
}, InitializePointerEvent:function(gestureElement) {
  var touchAction = PointerEventGenerator.TouchAction.NONE;
  switch(gestureElement.getAttribute(GwdGestureConstants.Attributes.TOUCH_ACTION)) {
    case GwdGestureConstants.TouchAction.AUTO:
      touchAction = PointerEventGenerator.TouchAction.AUTO;
      break;
    case GwdGestureConstants.TouchAction.PAN_X:
      touchAction = PointerEventGenerator.TouchAction.PAN_X;
      break;
    case GwdGestureConstants.TouchAction.PAN_Y:
      touchAction = PointerEventGenerator.TouchAction.PAN_Y;
  }
  PointerEventGenerator.initialize(gestureElement, touchAction);
}};
var GwdSwipeGestureUtil = {ANGLE_THRESHOLD_:.92, computeMagnitude_:function(x, y) {
  return Math.sqrt(x * x + y * y);
}, withinAngleThreshold_:function(primaryDist, perpDist) {
  var length = GwdSwipeGestureUtil.computeMagnitude_(primaryDist, perpDist), primaryNorm = Math.abs(primaryDist / length);
  return primaryNorm > GwdSwipeGestureUtil.ANGLE_THRESHOLD_;
}, exceedsDistanceThreshold_:function(targetDimension, d, threshold) {
  return Math.abs(d) >= targetDimension * threshold;
}, isSwipe:function(target, dx, dy, dt, distanceThreshold, velocityThreshold) {
  var vx = dx / dt, vy = dy / dt, v = GwdSwipeGestureUtil.computeMagnitude_(vx, vy);
  if (Math.abs(v) < velocityThreshold) {
    return !1;
  }
  switch(GwdSwipeGestureUtil.getSwipeEventName(dx, dy)) {
    case EventTypes.SWIPE_UP:
    ;
    case EventTypes.SWIPE_DOWN:
      return GwdSwipeGestureUtil.withinAngleThreshold_(dy, dx) && GwdSwipeGestureUtil.exceedsDistanceThreshold_(target.clientHeight, dy, distanceThreshold);
    case EventTypes.SWIPE_LEFT:
    ;
    case EventTypes.SWIPE_RIGHT:
      return GwdSwipeGestureUtil.withinAngleThreshold_(dx, dy) && GwdSwipeGestureUtil.exceedsDistanceThreshold_(target.clientWidth, dx, distanceThreshold);
    default:
      return !1;
  }
}, getSwipeEventName:function(dx, dy) {
  return Math.abs(dx) >= Math.abs(dy) ? 0 < dx ? EventTypes.SWIPE_RIGHT : EventTypes.SWIPE_LEFT : 0 < dy ? EventTypes.SWIPE_DOWN : EventTypes.SWIPE_UP;
}};
var GWDGestureElementImpl = function() {
};
goog.inherits(GWDGestureElementImpl, HTMLElement);
GWDGestureElementImpl.prototype.createdCallback = function() {
  this.activePointers_ = {};
  this.tapInvalidated_ = !1;
  this.overHandler_ = EventUtil.dispatch.bind(null, EventTypes.HOVER, this);
  this.downHandler_ = this.down_.bind(this);
  this.moveHandler_ = this.move_.bind(this);
  this.upHandler_ = this.up_.bind(this);
  this.outHandler_ = this.out_.bind(this);
  this.cancelHandler_ = this.cancel_.bind(this);
  this.velocityThreshold_ = this.hasAttribute(GwdGestureConstants.Attributes.SWIPE_VELOCITY) ? parseFloat(this.getAttribute(GwdGestureConstants.Attributes.SWIPE_VELOCITY)) : GwdGestureConstants.DEFAULT_SWIPE_VELOCITY;
  this.distanceThreshold_ = this.hasAttribute(GwdGestureConstants.Attributes.SWIPE_DISTANCE) ? parseFloat(this.getAttribute(GwdGestureConstants.Attributes.SWIPE_DISTANCE)) : GwdGestureConstants.DEFAULT_SWIPE_DISTANCE;
  GwdGestureUtil.InitializePointerEvent(this);
};
GWDGestureElementImpl.prototype.attachedCallback = function() {
  this.addEventListener(PointerEventGenerator.Events.OVER, this.overHandler_, !1);
  this.addEventListener(PointerEventGenerator.Events.DOWN, this.downHandler_, !1);
  this.addEventListener(PointerEventGenerator.Events.MOVE, this.moveHandler_, !1);
  this.addEventListener(PointerEventGenerator.Events.UP, this.upHandler_, !1);
  this.addEventListener(PointerEventGenerator.Events.OUT, this.outHandler_, !1);
  this.addEventListener(PointerEventGenerator.Events.CANCEL, this.cancelHandler_, !1);
};
GWDGestureElementImpl.prototype.detachedCallback = function() {
  this.removeEventListener(PointerEventGenerator.Events.OVER, this.overHandler_, !1);
  this.removeEventListener(PointerEventGenerator.Events.DOWN, this.downHandler_, !1);
  this.removeEventListener(PointerEventGenerator.Events.MOVE, this.moveHandler_, !1);
  this.removeEventListener(PointerEventGenerator.Events.UP, this.upHandler_, !1);
  this.removeEventListener(PointerEventGenerator.Events.OUT, this.outHandler_, !1);
  this.removeEventListener(PointerEventGenerator.Events.CANCEL, this.cancelHandler_, !1);
};
GWDGestureElementImpl.prototype.down_ = function(event) {
  event.isPrimary && (this.addPointer_(event), this.tapInvalidated_ = !1);
};
GWDGestureElementImpl.prototype.move_ = function(event) {
  var key = GwdGestureUtil.getPointerKey(event), pointer = this.activePointers_[key];
  pointer && (GwdGestureUtil.shouldInvalidateTap(pointer, event) && (this.tapInvalidated_ = !0), pointer.tracking || (this.dispatchEvent(GwdGestureUtil.createTrackStartEvent(pointer)), pointer.tracking = !0), this.dispatchEvent(GwdGestureUtil.createTrackEvent(pointer, event)), pointer.lastX = event.clientX, pointer.lastY = event.clientY);
};
GWDGestureElementImpl.prototype.up_ = function(event) {
  this.upOut_(event) && (this.tapInvalidated_ || this.dispatchEvent(GwdGestureUtil.createTapEvent(event)));
};
GWDGestureElementImpl.prototype.out_ = function(event) {
  this.upOut_(event);
  EventUtil.dispatch(EventTypes.HOVER_END, this);
};
GWDGestureElementImpl.prototype.upOut_ = function(event) {
  var key = GwdGestureUtil.getPointerKey(event), pointer = this.activePointers_[key];
  pointer && (pointer.tracking && (this.dispatchEvent(GwdGestureUtil.createTrackEndEvent(pointer, event)), this.maybeDispatchSwipe_(pointer, event)), this.removePointer_(event));
  return pointer;
};
GWDGestureElementImpl.prototype.cancel_ = function(event) {
  this.removePointer_(event);
  this.tapInvalidated_ = !0;
};
GWDGestureElementImpl.prototype.removePointer_ = function(event) {
  var id = GwdGestureUtil.getPointerKey(event);
  this.activePointers_[id] && delete this.activePointers_[id];
};
GWDGestureElementImpl.prototype.addPointer_ = function(event) {
  var id = GwdGestureUtil.getPointerKey(event);
  this.activePointers_[id] || (this.activePointers_[id] = {downX:event.clientX, downY:event.clientY, downTime:EventUtil.getNormalizedEventTimeStamp(event), lastX:event.clientX, lastY:event.clientY, tracking:!1});
};
GWDGestureElementImpl.prototype.maybeDispatchSwipe_ = function(pointer, event) {
  var dt = EventUtil.getNormalizedEventTimeStamp(event) - pointer.downTime, dx = event.clientX - pointer.downX, dy = event.clientY - pointer.downY;
  if (GwdSwipeGestureUtil.isSwipe(this, dx, dy, dt, this.distanceThreshold_, this.velocityThreshold_)) {
    var eventName = GwdSwipeGestureUtil.getSwipeEventName(dx, dy);
    EventUtil.dispatch(eventName, this);
  }
};
GWDGestureElementImpl.prototype.attributeChangedCallback = GWDCustomElementConstants.nullFunction;
document.registerElement(GwdGestureConstants.TAG_NAME, {prototype:GWDGestureElementImpl.prototype});

})();
