(function(){
"use strict";
var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var DomUtil = {CLASS_NAME_SELECTOR_PREFIX_:".", REFLOW_ATTRIBUTE_NAME_:"gwd-reflow", NodeType:{ELEMENT:1, ATTRIBUTE:2, TEXT:3, CDATA_SECTION:4, ENTITY_REFERENCE:5, ENTITY:6, PROCESSING_INSTRUCTION:7, COMMENT:8, DOCUMENT:9, DOCUMENT_TYPE:10, DOCUMENT_FRAGMENT:11, NOTATION:12}, selectByClassName:function(root, className) {
  return root.querySelector(DomUtil.CLASS_NAME_SELECTOR_PREFIX_ + className);
}, contains:function(parent, descendant) {
  if (parent.contains && descendant.nodeType == DomUtil.NodeType.ELEMENT) {
    return parent == descendant || parent.contains(descendant);
  }
  if ("undefined" != typeof parent.compareDocumentPosition) {
    return parent == descendant || Boolean(parent.compareDocumentPosition(descendant) & 16);
  }
  for (;descendant && parent != descendant;) {
    descendant = descendant.parentNode;
  }
  return descendant == parent;
}, maybeLoadElement:function(element) {
  if ("function" == typeof element.gwdLoad && "function" == typeof element.gwdIsLoaded && !element.gwdIsLoaded()) {
    var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsLoaded = wrapperPage && "function" == typeof wrapperPage.gwdIsLoaded;
    (!wrapperPage || wrapperPageImplementsIsLoaded && wrapperPage.gwdIsLoaded()) && element.gwdLoad();
  }
}, maybeActivateElement:function(element) {
  if (null == element.gwdActivate || "function" == typeof element.gwdActivate) {
    if (null == element.gwdIsActive || !element.gwdIsActive()) {
      var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsActive = wrapperPage && null != wrapperPage.gwdIsActive && "function" == typeof wrapperPage.gwdIsActive;
      null == wrapperPage && element.gwdActivate();
      wrapperPageImplementsIsActive && wrapperPage.gwdIsActive() && element.gwdActivate();
    }
  }
}, isGwdPage_:function(element) {
  return element.tagName.toLowerCase() == GwdPageConstants.TAG_NAME || element.getAttribute("is") == GwdPageConstants.TAG_NAME;
}, closest:function(element, matcher) {
  if (matcher(element)) {
    return element;
  }
  for (;element && element.nodeType != DomUtil.NodeType.DOCUMENT;) {
    if ((element = element.parentElement) && matcher(element)) {
      return element;
    }
  }
  return null;
}, isAttachedToDom:function(element) {
  return !(element.ownerDocument.compareDocumentPosition(element) & Node.DOCUMENT_POSITION_DISCONNECTED);
}, createElement:function(tagName) {
  return document.createElement(tagName);
}, ancestors:function(child) {
  for (var ancestors = [], node = child;node;node = node.parentNode) {
    ancestors.unshift(node);
  }
  return ancestors;
}, commonAncestor:function(node1, node2) {
  for (var ancestors1 = DomUtil.ancestors(node1), ancestors2 = DomUtil.ancestors(node2), i = 0, a1 = ancestors1[0], a2 = ancestors2[0], commonAncestor = null;a1 && a2 && a1 == a2;) {
    commonAncestor = a1, i++, a1 = ancestors1[i], a2 = ancestors2[i];
  }
  return commonAncestor;
}, reflow:function(element) {
  element.setAttribute(DomUtil.REFLOW_ATTRIBUTE_NAME_, element.offsetWidth);
}, getIntegerAttribute:function(element, name, defaultValue) {
  var value = parseInt(element.getAttribute(name), 10);
  isNaN(value) && (value = defaultValue);
  return value;
}, getFloatAttribute:function(element, name, defaultValue) {
  var value = parseFloat(element.getAttribute(name));
  isFinite(value) || (value = defaultValue);
  return value;
}, getStringAttribute:function(element, name, defaultValue) {
  return element.hasAttribute(name) ? element.getAttribute(name) : defaultValue;
}, getBooleanAttribute:function(element, name, defaultValue) {
  switch(element.getAttribute(name)) {
    case "true":
      return !0;
    case "false":
      return !1;
    default:
      return defaultValue;
  }
}, setAttributeIfDifferent:function(element, name, value) {
  return value != element.getAttribute(name) ? (element.setAttribute(name, value), !0) : !1;
}, copyAttribute:function(sourceEl, sourceName, destEl, opt_destName) {
  opt_destName = opt_destName || sourceName;
  if (sourceEl.hasAttribute(sourceName)) {
    var value = sourceEl.getAttribute(sourceName);
    destEl.setAttribute(opt_destName, value);
  } else {
    destEl.removeAttribute(opt_destName);
  }
}};
var GwdImageConstants = {NONE_SCALING_BACKGROUND_SIZE_:"auto", TAG_NAME:"gwd-image", BLANK_TRANSPARENT_GIF:"data:image/gif;base64,R0lGODlhAQABAPAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==", EXTENDS_TAG_NAME:"img", Attributes:{SCALING:"scaling", SOURCE:"source", SRC:"src"}, States:{INIT:0, PENDING:1, LOADED:2, ERROR:3}, ScalingModes:{CONTAIN:"contain", COVER:"cover", NONE:"none", STRETCH:"stretch"}};
GwdImageConstants.Defaults = {SCALING:GwdImageConstants.ScalingModes.STRETCH};
GwdImageConstants.StyleClasses = {SCALED_PROPORTIONALLY:"scaled-proportionally"};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var GWDImageElementImpl = function() {
};
goog.inherits(GWDImageElementImpl, HTMLImageElement);
GWDImageElementImpl.prototype.createdCallback = function() {
  this.imageLoadedHandler_ = this.handleLoad_.bind(this);
  this.state_ = GwdImageConstants.States.INIT;
  var src = this.getAttribute(GwdImageConstants.Attributes.SRC);
  src && (this.setAttribute(GwdImageConstants.Attributes.SOURCE, src), this.removeAttribute(GwdImageConstants.Attributes.SRC));
  this.addEventListener(EventTypes.LOAD, this.imageLoadedHandler_, !1);
  this.addEventListener(EventTypes.ERROR, this.imageLoadedHandler_, !1);
};
GWDImageElementImpl.prototype.attachedCallback = function() {
  DomUtil.maybeLoadElement(this);
};
GWDImageElementImpl.prototype.gwdIsLoaded = function() {
  return this.state_ == GwdImageConstants.States.LOADED || this.state_ == GwdImageConstants.States.ERROR;
};
GWDImageElementImpl.prototype.gwdLoad = function() {
  var source = this.getAttribute(GwdImageConstants.Attributes.SOURCE);
  source ? (this.state_ = GwdImageConstants.States.PENDING, this.setAttribute(GwdImageConstants.Attributes.SRC, source)) : EventUtil.dispatch(EventTypes.LOAD, this);
};
GWDImageElementImpl.prototype.handleLoad_ = function(evt) {
  this.state_ = evt && "error" == evt.type ? GwdImageConstants.States.ERROR : GwdImageConstants.States.LOADED;
  this.applyScaling_();
  EventUtil.dispatch(EventTypes.READY, this);
};
GWDImageElementImpl.prototype.applyScaling_ = function() {
  if (this.state_ == GwdImageConstants.States.LOADED) {
    var source = this.getAttribute(GwdImageConstants.Attributes.SOURCE), scaling = this.getAttribute(GwdImageConstants.Attributes.SCALING) || GwdImageConstants.Defaults.SCALING;
    source && (scaling != GwdImageConstants.ScalingModes.STRETCH ? (this.classList.add(GwdImageConstants.StyleClasses.SCALED_PROPORTIONALLY), this.style.backgroundImage = "url(" + JSON.stringify(source) + ")", this.style.backgroundSize = scaling != GwdImageConstants.ScalingModes.NONE ? scaling : GwdImageConstants.NONE_SCALING_BACKGROUND_SIZE_, DomUtil.setAttributeIfDifferent(this, GwdImageConstants.Attributes.SRC, GwdImageConstants.BLANK_TRANSPARENT_GIF)) : (this.classList.remove(GwdImageConstants.StyleClasses.SCALED_PROPORTIONALLY), 
    this.style.backgroundImage = "", DomUtil.setAttributeIfDifferent(this, GwdImageConstants.Attributes.SRC, source)));
  }
};
GWDImageElementImpl.prototype.attributeChangedCallback = function(attributeName) {
  GwdImageConstants.Attributes.SOURCE == attributeName && this.state_ !== GwdImageConstants.States.INIT && this.gwdLoad();
  GwdImageConstants.Attributes.SCALING == attributeName && this.applyScaling_();
};
document.registerElement(GwdImageConstants.TAG_NAME, {prototype:GWDImageElementImpl.prototype, "extends":GwdImageConstants.EXTENDS_TAG_NAME});

})();
