(function(){
"use strict";
var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var GWDCustomElementConstants = {nullFunction:null};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var GWDPageElementImpl = function() {
};
goog.inherits(GWDPageElementImpl, HTMLDivElement);
GWDPageElementImpl.prototype.createdCallback = function() {
  this.readyEventHandler_ = this.handleReadyEvent_.bind(this);
  this.childNodesToLoad_ = [];
  this.childrenProcessed_ = this.eventDispatchedInAttachedCallback_ = this.pageLoadedFired_ = !1;
  var pageWidth_ = parseInt(this.getAttribute(GwdPageConstants.Attributes.PAGE_WIDTH), 10) || this.clientWidth, pageHeight_ = parseInt(this.getAttribute(GwdPageConstants.Attributes.PAGE_HEIGHT), 10) || this.clientHeight;
  this.isPortrait_ = pageHeight_ >= pageWidth_;
  this.isActive_ = !1;
};
GWDPageElementImpl.prototype.attachedCallback = function() {
  this.addEventListener(EventTypes.READY, this.readyEventHandler_, !1);
  ClockUtil.setTimeout(function() {
    var childNodes = Array.prototype.slice.call(this.querySelectorAll("*"));
    this.childNodesToLoad_ = childNodes.filter(function(node) {
      return "function" != typeof node.gwdLoad || "function" != typeof node.gwdIsLoaded || node.gwdIsLoaded() ? !1 : !0;
    }, this);
    this.childrenProcessed_ = !0;
    0 < this.childNodesToLoad_.length ? (this.style.visibility = "hidden", this.pageLoadedFired_ = !1) : this.firePageReadyEvent_();
    this.eventDispatchedInAttachedCallback_ = !0;
    EventUtil.dispatch(EventTypes.ATTACHED, this);
  }.bind(this), 0);
};
GWDPageElementImpl.prototype.detachedCallback = function() {
  this.removeEventListener(EventTypes.READY, this.readyEventHandler_, !1);
  this.classList.remove(GwdPageConstants.PLAY_ANIMATION);
  EventUtil.dispatch(EventTypes.DETACHED, this);
};
GWDPageElementImpl.prototype.gwdActivate = function() {
  this.classList.remove(GwdPageConstants.INACTIVE);
  var childNodes = Array.prototype.slice.call(this.querySelectorAll("*"));
  childNodes.forEach(function(node) {
    "function" == typeof node.gwdActivate && "function" == typeof node.gwdIsActive && 0 == node.gwdIsActive() && node.gwdActivate();
  });
  this.isActive_ = !0;
  this.eventDispatchedInAttachedCallback_ ? this.eventDispatchedInAttachedCallback_ = !1 : EventUtil.dispatch(EventTypes.ATTACHED, this);
  EventUtil.dispatch(GwdPageConstants.Events.PAGE_ACTIVATED, this);
};
GWDPageElementImpl.prototype.gwdDeactivate = function() {
  this.classList.add(GwdPageConstants.INACTIVE);
  this.classList.remove(GwdPageConstants.PLAY_ANIMATION);
  var childNodes = Array.prototype.slice.call(this.querySelectorAll("*"));
  childNodes.forEach(function(node) {
    "function" == typeof node.gwdDeactivate && "function" == typeof node.gwdIsActive && 1 == node.gwdIsActive() && node.gwdDeactivate();
  });
  this.isActive_ = !1;
  EventUtil.dispatch(GwdPageConstants.Events.PAGE_DEACTIVATED, this);
  EventUtil.dispatch(EventTypes.DETACHED, this);
};
GWDPageElementImpl.prototype.gwdIsActive = function() {
  return this.isActive_;
};
GWDPageElementImpl.prototype.gwdIsLoaded = function() {
  return this.childrenProcessed_ && 0 == this.childNodesToLoad_.length;
};
GWDPageElementImpl.prototype.gwdLoad = function() {
  if (this.gwdIsLoaded()) {
    this.firePageReadyEvent_();
  } else {
    for (var i = this.childNodesToLoad_.length - 1;0 <= i;i--) {
      this.childNodesToLoad_[i].gwdLoad();
    }
  }
};
GWDPageElementImpl.prototype.handleReadyEvent_ = function(event) {
  var index = this.childNodesToLoad_.indexOf(event.target);
  0 <= index && (this.childNodesToLoad_.splice(index, 1), 0 == this.childNodesToLoad_.length && this.firePageReadyEvent_());
};
GWDPageElementImpl.prototype.firePageReadyEvent_ = function() {
  this.style.visibility = "";
  this.pageLoadedFired_ || (EventUtil.dispatch(EventTypes.READY, this), EventUtil.dispatch(EventTypes.PAGE_LOAD, this));
  this.pageLoadedFired_ = !0;
};
GWDPageElementImpl.prototype.gwdPresent = function() {
  EventUtil.dispatch(GwdPageConstants.Events.PAGE_PRESENTING, this);
  this.classList.add(GwdPageConstants.PLAY_ANIMATION);
};
GWDPageElementImpl.prototype.isPortrait = function() {
  return this.isPortrait_;
};
GWDPageElementImpl.prototype.attributeChangedCallback = GWDCustomElementConstants.nullFunction;
document.registerElement(GwdPageConstants.TAG_NAME, {prototype:GWDPageElementImpl.prototype, "extends":GwdPageConstants.EXTENDS_TAG_NAME});

})();
