(function(){
"use strict";
var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var DomUtil = {CLASS_NAME_SELECTOR_PREFIX_:".", REFLOW_ATTRIBUTE_NAME_:"gwd-reflow", NodeType:{ELEMENT:1, ATTRIBUTE:2, TEXT:3, CDATA_SECTION:4, ENTITY_REFERENCE:5, ENTITY:6, PROCESSING_INSTRUCTION:7, COMMENT:8, DOCUMENT:9, DOCUMENT_TYPE:10, DOCUMENT_FRAGMENT:11, NOTATION:12}, selectByClassName:function(root, className) {
  return root.querySelector(DomUtil.CLASS_NAME_SELECTOR_PREFIX_ + className);
}, contains:function(parent, descendant) {
  if (parent.contains && descendant.nodeType == DomUtil.NodeType.ELEMENT) {
    return parent == descendant || parent.contains(descendant);
  }
  if ("undefined" != typeof parent.compareDocumentPosition) {
    return parent == descendant || Boolean(parent.compareDocumentPosition(descendant) & 16);
  }
  for (;descendant && parent != descendant;) {
    descendant = descendant.parentNode;
  }
  return descendant == parent;
}, maybeLoadElement:function(element) {
  if ("function" == typeof element.gwdLoad && "function" == typeof element.gwdIsLoaded && !element.gwdIsLoaded()) {
    var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsLoaded = wrapperPage && "function" == typeof wrapperPage.gwdIsLoaded;
    (!wrapperPage || wrapperPageImplementsIsLoaded && wrapperPage.gwdIsLoaded()) && element.gwdLoad();
  }
}, maybeActivateElement:function(element) {
  if (null == element.gwdActivate || "function" == typeof element.gwdActivate) {
    if (null == element.gwdIsActive || !element.gwdIsActive()) {
      var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsActive = wrapperPage && null != wrapperPage.gwdIsActive && "function" == typeof wrapperPage.gwdIsActive;
      null == wrapperPage && element.gwdActivate();
      wrapperPageImplementsIsActive && wrapperPage.gwdIsActive() && element.gwdActivate();
    }
  }
}, isGwdPage_:function(element) {
  return element.tagName.toLowerCase() == GwdPageConstants.TAG_NAME || element.getAttribute("is") == GwdPageConstants.TAG_NAME;
}, closest:function(element, matcher) {
  if (matcher(element)) {
    return element;
  }
  for (;element && element.nodeType != DomUtil.NodeType.DOCUMENT;) {
    if ((element = element.parentElement) && matcher(element)) {
      return element;
    }
  }
  return null;
}, isAttachedToDom:function(element) {
  return !(element.ownerDocument.compareDocumentPosition(element) & Node.DOCUMENT_POSITION_DISCONNECTED);
}, createElement:function(tagName) {
  return document.createElement(tagName);
}, ancestors:function(child) {
  for (var ancestors = [], node = child;node;node = node.parentNode) {
    ancestors.unshift(node);
  }
  return ancestors;
}, commonAncestor:function(node1, node2) {
  for (var ancestors1 = DomUtil.ancestors(node1), ancestors2 = DomUtil.ancestors(node2), i = 0, a1 = ancestors1[0], a2 = ancestors2[0], commonAncestor = null;a1 && a2 && a1 == a2;) {
    commonAncestor = a1, i++, a1 = ancestors1[i], a2 = ancestors2[i];
  }
  return commonAncestor;
}, reflow:function(element) {
  element.setAttribute(DomUtil.REFLOW_ATTRIBUTE_NAME_, element.offsetWidth);
}, getIntegerAttribute:function(element, name, defaultValue) {
  var value = parseInt(element.getAttribute(name), 10);
  isNaN(value) && (value = defaultValue);
  return value;
}, getFloatAttribute:function(element, name, defaultValue) {
  var value = parseFloat(element.getAttribute(name));
  isFinite(value) || (value = defaultValue);
  return value;
}, getStringAttribute:function(element, name, defaultValue) {
  return element.hasAttribute(name) ? element.getAttribute(name) : defaultValue;
}, getBooleanAttribute:function(element, name, defaultValue) {
  switch(element.getAttribute(name)) {
    case "true":
      return !0;
    case "false":
      return !1;
    default:
      return defaultValue;
  }
}, setAttributeIfDifferent:function(element, name, value) {
  return value != element.getAttribute(name) ? (element.setAttribute(name, value), !0) : !1;
}, copyAttribute:function(sourceEl, sourceName, destEl, opt_destName) {
  opt_destName = opt_destName || sourceName;
  if (sourceEl.hasAttribute(sourceName)) {
    var value = sourceEl.getAttribute(sourceName);
    destEl.setAttribute(opt_destName, value);
  } else {
    destEl.removeAttribute(opt_destName);
  }
}};
var GWDCustomElementConstants = {nullFunction:null};
var GwdPageDeckConstants = {TAG_NAME:"gwd-pagedeck", EXTENDS_TAG_NAME:"div", Attributes:{TRANSITION_CLASS:"transition-class", DEFAULT_PAGE:"default-page"}, Events:{BEFORE_PAGES_DETACHED:"beforepagesdetached", PAGE_TRANSITION_START:"pagetransitionstart", PAGE_TRANSITION_END:"pagetransitionend"}};
var PageTransitionConstants = {DEFAULT_DURATION:1E3, TYPE:{NONE:"none", SLIDE:"slide", FADE:"fade", PUSH:"push"}, EASING:{LINEAR:"linear", EASE:"ease", EASE_IN:"ease-in", EASE_OUT:"ease-out", EASE_IN_OUT:"ease-in-out"}, DIRECTION:{TOP:"top", BOTTOM:"bottom", LEFT:"left", RIGHT:"right"}, POSITION:{CENTER:"center", TOP:"top", BOTTOM:"bottom", LEFT:"left", RIGHT:"right"}, EFFECTS:{TRANSPARENT:"transparent"}};
var CssUtil = {Attributes:{TRANSITION_DURATION:"transition-duration"}, browserPrefixes_:["-ms-", "-moz-", "-webkit-", ""], applyCssWithBrowserPrefix:function(element, name, value, opt_prefixOnValue) {
  for (var propertyName, propertyValue, i = 0;i < CssUtil.browserPrefixes_.length;++i) {
    propertyName = CssUtil.browserPrefixes_[i] + name, propertyValue = (opt_prefixOnValue ? CssUtil.browserPrefixes_[i] : "") + value, element.style.setProperty(propertyName, propertyValue);
  }
}, getPropertyValue:function(element, name) {
  for (var falseyValue = null, value, i = 0;i < CssUtil.browserPrefixes_.length;++i) {
    if (value = element.style.getPropertyValue(CssUtil.browserPrefixes_[i] + name)) {
      return value;
    }
    null != value && (falseyValue = value);
  }
  return falseyValue;
}, installStyles:function(stylesString) {
  var styleSheet = null, doc = document, isIE = -1 != navigator.userAgent.indexOf("MSIE");
  if (isIE && doc.createStyleSheet) {
    styleSheet = doc.createStyleSheet(), styleSheet.cssText = stylesString;
  } else {
    var head = doc.getElementsByTagName("head")[0];
    if (!head) {
      var body = doc.getElementsByTagName("body")[0], head = doc.createElement("head");
      body.parentNode.insertBefore(head, body);
    }
    styleSheet = doc.createElement("style");
    styleSheet.innerHTML = stylesString;
    head.appendChild(styleSheet);
  }
  return styleSheet;
}, uninstallStyles:function(styleSheet) {
  var node = styleSheet.ownerNode || styleSheet.owningElement || styleSheet;
  node && node.parentNode && node.parentNode.removeChild(node);
}, isElementShown:function(el) {
  return "none" != el.style.display;
}, setElementShown:function(el, isShown) {
  el.style.display = isShown ? "" : "none";
}};
function PageTransition(fromPage, toPage, completeCallback, opt_transition, opt_duration, opt_easing, opt_direction) {
  this.fromPage_ = fromPage;
  this.toPage_ = toPage;
  this.onComplete_ = completeCallback;
  var transition = opt_transition || PageTransitionConstants.TYPE.NONE, duration = transition === PageTransitionConstants.TYPE.NONE ? 0 : opt_duration || PageTransitionConstants.DEFAULT_DURATION;
  this.duration_ = duration;
  this.easing_ = opt_easing || PageTransitionConstants.EASING.LINEAR;
  this.fromPageClassNames_ = [];
  duration && this.setUpTransition_(transition, opt_direction || PageTransitionConstants.DIRECTION.TOP);
}
PageTransition.prototype.getFromPage = function() {
  return this.fromPage_;
};
PageTransition.prototype.getToPage = function() {
  return this.toPage_;
};
PageTransition.prototype.start = function() {
  if (this.duration_) {
    var fromPage = this.fromPage_, toPage = this.toPage_;
    PageTransition.addTransitionEndListenerOnce_(toPage, this.onTransitionEnd_.bind(this));
    fromPage && (CssUtil.applyCssWithBrowserPrefix(fromPage, CssUtil.Attributes.TRANSITION_DURATION, this.duration_ + "ms"), fromPage.classList.add(this.easing_));
    CssUtil.applyCssWithBrowserPrefix(toPage, CssUtil.Attributes.TRANSITION_DURATION, this.duration_ + "ms");
    toPage.classList.add(this.easing_);
    DomUtil.reflow(toPage);
    if (fromPage) {
      for (var i = 0;i < this.fromPageClassNames_.length;++i) {
        fromPage.classList.add(this.fromPageClassNames_[i]);
      }
    }
    PageTransition.removeAllTransitionClasses_(toPage);
  } else {
    this.onComplete_();
  }
};
PageTransition.appendTransitionStyle = function(id, width, height) {
  var css = PageTransition.buildCss_(id, width, height), style = document.createElement("style");
  void 0 !== style.cssText ? style.cssText = css : style.innerHTML = css;
  document.head.appendChild(style);
  return style;
};
PageTransition.buildCssSelector_ = function(id) {
  return (id && "#") + id + "." + GwdPageDeckConstants.TAG_NAME + " > ." + GwdPageConstants.TAG_NAME;
};
PageTransition.buildOneCssRule_ = function(selector, className, x, y) {
  var transformMatrix = "transform: matrix3d(1,0,0,0,0,1,0,0,0,0,1,0," + x + "," + y + ",0,1);";
  return selector + "." + className + "{-webkit-" + transformMatrix + "-moz-" + transformMatrix + "-ms-" + transformMatrix + transformMatrix + "}";
};
PageTransition.buildCss_ = function(id, width, height) {
  var selector = PageTransition.buildCssSelector_(id);
  return PageTransition.buildOneCssRule_(selector, PageTransitionConstants.POSITION.CENTER, 0, 0) + PageTransition.buildOneCssRule_(selector, PageTransitionConstants.POSITION.TOP, 0, height) + PageTransition.buildOneCssRule_(selector, PageTransitionConstants.POSITION.BOTTOM, 0, -height) + PageTransition.buildOneCssRule_(selector, PageTransitionConstants.POSITION.LEFT, width, 0) + PageTransition.buildOneCssRule_(selector, PageTransitionConstants.POSITION.RIGHT, -width, 0);
};
PageTransition.chooseToPageInitialPosition_ = function(transition, direction) {
  var position = PageTransitionConstants.POSITION.CENTER;
  if (transition != PageTransitionConstants.TYPE.NONE && transition != PageTransitionConstants.TYPE.FADE) {
    switch(direction) {
      case PageTransitionConstants.DIRECTION.TOP:
        position = PageTransitionConstants.POSITION.BOTTOM;
        break;
      case PageTransitionConstants.DIRECTION.BOTTOM:
        position = PageTransitionConstants.POSITION.TOP;
        break;
      case PageTransitionConstants.DIRECTION.LEFT:
        position = PageTransitionConstants.POSITION.RIGHT;
        break;
      case PageTransitionConstants.DIRECTION.RIGHT:
        position = PageTransitionConstants.POSITION.LEFT;
    }
  }
  return position;
};
PageTransition.chooseFromPageFinalPosition_ = function(transition, direction) {
  var position = PageTransitionConstants.POSITION.CENTER;
  if (transition == PageTransitionConstants.TYPE.PUSH) {
    switch(direction) {
      case PageTransitionConstants.DIRECTION.TOP:
        position = PageTransitionConstants.POSITION.TOP;
        break;
      case PageTransitionConstants.DIRECTION.BOTTOM:
        position = PageTransitionConstants.POSITION.BOTTOM;
        break;
      case PageTransitionConstants.DIRECTION.LEFT:
        position = PageTransitionConstants.POSITION.LEFT;
        break;
      case PageTransitionConstants.DIRECTION.RIGHT:
        position = PageTransitionConstants.POSITION.RIGHT;
    }
  }
  return position;
};
PageTransition.allTransitionClasses_ = [PageTransitionConstants.POSITION.CENTER, PageTransitionConstants.POSITION.TOP, PageTransitionConstants.POSITION.BOTTOM, PageTransitionConstants.POSITION.LEFT, PageTransitionConstants.POSITION.RIGHT, PageTransitionConstants.EFFECTS.TRANSPARENT];
PageTransition.removeAllTransitionClasses_ = function(element) {
  PageTransition.allTransitionClasses_.forEach(function(className) {
    element.classList.remove(className);
  });
};
PageTransition.prototype.setUpTransition_ = function(transition, direction) {
  var fromPage = this.fromPage_;
  fromPage && (fromPage.classList.add(GwdPageConstants.TAG_NAME), fromPage.classList.add(PageTransitionConstants.POSITION.CENTER), this.fromPageClassNames_.push(PageTransition.chooseFromPageFinalPosition_(transition, direction)), transition == PageTransitionConstants.TYPE.FADE && this.fromPageClassNames_.push(PageTransitionConstants.EFFECTS.TRANSPARENT));
  var toPage = this.toPage_;
  toPage.classList.add(PageTransition.chooseToPageInitialPosition_(transition, direction));
  toPage.classList.add(GwdPageConstants.TAG_NAME);
  transition == PageTransitionConstants.TYPE.FADE && toPage.classList.add(PageTransitionConstants.EFFECTS.TRANSPARENT);
};
PageTransition.addTransitionEndListenerOnce_ = function(target, transitionEndCallback) {
  var onTransitionEnd = function() {
    target.removeEventListener(EventTypes.WEBKIT_TRANSITION_END, onTransitionEnd);
    target.removeEventListener(EventTypes.TRANSITION_END, onTransitionEnd);
    transitionEndCallback();
  };
  target.addEventListener(EventTypes.WEBKIT_TRANSITION_END, onTransitionEnd);
  target.addEventListener(EventTypes.TRANSITION_END, onTransitionEnd);
};
PageTransition.prototype.onTransitionEnd_ = function() {
  var fromPage = this.fromPage_;
  fromPage && (PageTransition.removeAllTransitionClasses_(fromPage), CssUtil.applyCssWithBrowserPrefix(fromPage, CssUtil.Attributes.TRANSITION_DURATION, 0), fromPage.classList.remove(this.easing_));
  CssUtil.applyCssWithBrowserPrefix(this.toPage_, CssUtil.Attributes.TRANSITION_DURATION, 0);
  this.toPage_.classList.remove(this.easing_);
  this.onComplete_();
};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var GwdDoubleClickConstants = {EVENT_DETAIL_URL:"url", EXPANDED_PAGE:"data-gwd-expanded", FULLSCREEN_CLASS_NAME:"fs", GWD_DATABINDER:"gwd-data-binder", GWD_YOUTUBE:"gwd-youtube", HANDLED:"handled", HTML_AUDIO:"audio", HTML_VIDEO:"video", START_PAGE_TRANSITION_DELAY:30, TAG_NAME:"gwd-doubleclick", Attributes:{DATA_PROVIDER:"data-provider", FULLSCREEN:"fullscreen", POLITE_LOAD:"polite-load"}, Events:{AD_INITIALIZED:"adinitialized", COLLAPSE_FINISH:"collapsefinish", COLLAPSE_START:"collapsestart", EXPAND_FINISH:"expandfinish", 
EXPAND_START:"expandstart", FULLSCREEN_SUPPORT:"fullscreensupport"}};
var BrowserUtil = {Orientation:{PORTRAIT:1, LANDSCAPE:2}, getUserAgentString_:function() {
  return window.navigator.userAgent || "";
}, isWebKit:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("WebKit");
}, isAndroid:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("Android");
}, isFirefox:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 != userAgent.indexOf("rv:") && -1 != userAgent.indexOf("Gecko");
}, isIE:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 < userAgent.indexOf("Trident") || -1 < userAgent.indexOf("MSIE");
}, isGwdDoubleClick_:function(element) {
  return element.tagName.toLowerCase() == GwdDoubleClickConstants.TAG_NAME;
}, openUrl:function(url) {
  window.open(url);
}, getOrientation:function() {
  return BrowserUtil.isPortrait_() ? BrowserUtil.Orientation.PORTRAIT : BrowserUtil.Orientation.LANDSCAPE;
}, isPortrait_:function() {
  return window.innerHeight >= window.innerWidth;
}, getQueryString:function() {
  return window.location.search;
}, setQueryString:function(queryString) {
  window.location.search = queryString;
}};
var GWDPageDeckElementImpl = function() {
};
goog.inherits(GWDPageDeckElementImpl, HTMLDivElement);
GWDPageDeckElementImpl.prototype.createdCallback = function() {
  window.addEventListener(EventTypes.WEB_COMPONENTS_READY, this.handleWebComponentsReadyEvent_.bind(this), !1);
  this.forwardShakeHandler_ = this.forwardDeviceEventsToCurrentPage_.bind(this, EventTypes.SHAKE);
  this.forwardTiltHandler_ = this.forwardDeviceEventsToCurrentPage_.bind(this, EventTypes.TILT);
  this.forwardRotateToPortraitHandler_ = this.forwardDeviceEventsToCurrentPage_.bind(this, EventTypes.ROTATE_TO_PORTRAIT);
  this.forwardRotateToLandscapeHandler_ = this.forwardDeviceEventsToCurrentPage_.bind(this, EventTypes.ROTATE_TO_LANDSCAPE);
  this.pages_ = [];
  this.pageLoadedHandler_ = this.handlePageLoaded_.bind(this);
  this.endPageTransitionHandler_ = this.endPageTransition_.bind(this);
  this.pageTransition_ = this.pageTransitionStyle_ = null;
  this.currentIndex_ = -1;
  this.willTransition_ = !1;
  this.classList.add(GwdPageDeckConstants.TAG_NAME);
  Object.defineProperty(this, "currentIndex", {enumerable:!0, get:this.getCurrentIndex_.bind(this)});
};
GWDPageDeckElementImpl.prototype.handleWebComponentsReadyEvent_ = function() {
  this.pages_ = Array.prototype.slice.call(this.querySelectorAll("div[is=" + GwdPageConstants.TAG_NAME + "]"));
  this.pages_.forEach(function(page) {
    page.classList.add(GwdPageConstants.TAG_NAME);
  });
  for (EventUtil.dispatch(GwdPageDeckConstants.Events.BEFORE_PAGES_DETACHED, this, {pages:this.pages_.slice()});this.firstChild;) {
    this.removeChild(this.firstChild);
  }
  -1 == this.currentIndex_ && void 0 !== this.requestedPage_ && this.goToPage(this.requestedPage_);
};
GWDPageDeckElementImpl.prototype.attachedCallback = function() {
  this.pageTransitionStyle_ || (this.pageTransitionStyle_ = PageTransition.appendTransitionStyle(this.id, this.offsetWidth, this.offsetHeight));
  this.addEventListener(EventTypes.PAGE_LOAD, this.pageLoadedHandler_, !1);
  document.body.addEventListener(EventTypes.SHAKE, this.forwardShakeHandler_, !0);
  document.body.addEventListener(EventTypes.TILT, this.forwardTiltHandler_, !0);
  document.body.addEventListener(EventTypes.ROTATE_TO_PORTRAIT, this.forwardRotateToPortraitHandler_, !0);
  document.body.addEventListener(EventTypes.ROTATE_TO_LANDSCAPE, this.forwardRotateToLandscapeHandler_, !0);
};
GWDPageDeckElementImpl.prototype.detachedCallback = function() {
  this.removeEventListener(EventTypes.PAGE_LOAD, this.pageLoadedHandler_, !1);
  document.body.removeEventListener(EventTypes.SHAKE, this.forwardShakeHandler_, !0);
  document.body.removeEventListener(EventTypes.TILT, this.forwardTiltHandler_, !0);
  document.body.removeEventListener(EventTypes.ROTATE_TO_PORTRAIT, this.forwardRotateToPortraitHandler_, !0);
  document.body.removeEventListener(EventTypes.ROTATE_TO_LANDSCAPE, this.forwardRotateToLandscapeHandler_, !0);
};
GWDPageDeckElementImpl.prototype.goToPageImpl_ = function(index, opt_transition, opt_duration, opt_easing, opt_direction) {
  if (!(this.currentIndex_ == index || 0 > index || index > this.pages_.length - 1 || this.pageTransition_)) {
    var fromPage = this.pages_[this.currentIndex_], toPage = this.pages_[index];
    this.currentIndex_ = index;
    this.pageTransition_ = new PageTransition(fromPage, toPage, this.endPageTransitionHandler_, opt_transition, opt_duration, opt_easing, opt_direction);
    var loadToPage = toPage.gwdLoad && !toPage.gwdIsLoaded();
    this.willTransition_ = loadToPage;
    EventUtil.listenOnce(toPage, EventTypes.ATTACHED, function() {
      toPage.gwdActivate();
      loadToPage ? toPage.gwdLoad() : this.startPageTransition_();
    }.bind(this));
    this.appendChild(toPage);
  }
};
GWDPageDeckElementImpl.prototype.handlePageLoaded_ = function(e) {
  this.willTransition_ && e.target.parentNode == this && (this.startPageTransition_(), this.willTransition_ = !1);
};
GWDPageDeckElementImpl.prototype.startPageTransition_ = function() {
  EventUtil.dispatch(GwdPageDeckConstants.Events.PAGE_TRANSITION_START, this);
  this.pageTransition_.start();
};
GWDPageDeckElementImpl.prototype.endPageTransition_ = function() {
  if (this.pageTransition_) {
    var currentPage = this.pageTransition_.getFromPage(), nextPage = this.pageTransition_.getToPage();
    this.pageTransition_ = null;
    var firstPageView = !currentPage, eventDetail = {outgoingPage:firstPageView ? null : currentPage, incomingPage:nextPage};
    EventUtil.dispatch(GwdPageDeckConstants.Events.PAGE_TRANSITION_END, this, eventDetail);
    currentPage && currentPage.gwdDeactivate();
    nextPage.gwdPresent();
  }
};
GWDPageDeckElementImpl.prototype.findPageIndexByAttributeValue = function(attributeName, value) {
  for (var len = this.pages_.length, page, i = 0;i < len;i++) {
    if (page = this.pages_[i], "boolean" == typeof value) {
      if (page.hasAttribute(attributeName)) {
        return i;
      }
    } else {
      if (page.getAttribute(attributeName) == value) {
        return i;
      }
    }
  }
  return -1;
};
GWDPageDeckElementImpl.prototype.goToNextPage = function(opt_loop, opt_transition, opt_duration, opt_easing, opt_direction) {
  var currentIndex = this.currentIndex_, numberOfPages = this.pages_.length, nextIndex = currentIndex + 1;
  nextIndex >= numberOfPages && (nextIndex = opt_loop ? 0 : currentIndex);
  this.goToPageImpl_(nextIndex, opt_transition, opt_duration, opt_easing, opt_direction);
};
GWDPageDeckElementImpl.prototype.goToPreviousPage = function(opt_loop, opt_transition, opt_duration, opt_easing, opt_direction) {
  var currentIndex = this.currentIndex_, numberOfPages = this.pages_.length, nextIndex = currentIndex - 1;
  0 > nextIndex && (nextIndex = opt_loop ? numberOfPages - 1 : currentIndex);
  this.goToPageImpl_(nextIndex, opt_transition, opt_duration, opt_easing, opt_direction);
};
GWDPageDeckElementImpl.prototype.goToPage = function(pageId, opt_transition, opt_duration, opt_easing, opt_direction) {
  var isInitialized = this.pages_.length;
  if (isInitialized) {
    var pageIndex = "number" == typeof pageId ? pageId : this.findPageIndexByAttributeValue("id", pageId);
    0 <= pageIndex && this.goToPageImpl_(pageIndex, opt_transition, opt_duration, opt_easing, opt_direction);
  } else {
    this.requestedPage_ = pageId;
  }
};
GWDPageDeckElementImpl.prototype.getCurrentIndex_ = function() {
  return 0 <= this.currentIndex_ ? this.currentIndex_ : void 0;
};
GWDPageDeckElementImpl.prototype.getPages = function() {
  return this.pages_;
};
GWDPageDeckElementImpl.prototype.getPage = function(pageIdOrIndex) {
  var index;
  if ("number" == typeof pageIdOrIndex) {
    index = pageIdOrIndex;
  } else {
    if (!pageIdOrIndex) {
      return null;
    }
    index = this.findPageIndexByAttributeValue("id", pageIdOrIndex);
  }
  return 0 > index || index > this.pages_.length - 1 ? null : this.pages_[index];
};
GWDPageDeckElementImpl.prototype.getDefaultPage = function() {
  var defaultPageId = this.getAttribute(GwdPageDeckConstants.Attributes.DEFAULT_PAGE);
  return defaultPageId ? this.getPage(this.findPageIndexByAttributeValue("id", defaultPageId)) : this.getPage(0);
};
GWDPageDeckElementImpl.prototype.getOrientationSpecificPage = function(orientation, pageId) {
  var page = this.getPage(pageId), altOrientationPageId = page.getAttribute(GwdPageConstants.Attributes.ALT_ORIENTATION_PAGE);
  if (!altOrientationPageId) {
    return page;
  }
  var isPagePortrait = page.isPortrait(), isPortrait = orientation == BrowserUtil.Orientation.PORTRAIT, altOrientationPage = this.getPage(altOrientationPageId);
  return isPortrait == isPagePortrait ? page : altOrientationPage;
};
GWDPageDeckElementImpl.prototype.forwardDeviceEventsToCurrentPage_ = function(eventName, e) {
  if (e.target == document.body) {
    var currentPage = this.getPage(this.currentIndex_);
    EventUtil.dispatch(eventName, currentPage, e.detail);
  }
};
GWDPageDeckElementImpl.prototype.getElementById = function(id) {
  for (var len = this.pages_.length, i = 0;i < len;i++) {
    var element = this.pages_[i].querySelector("#" + id);
    if (element) {
      return element;
    }
  }
  return null;
};
GWDPageDeckElementImpl.prototype.getElementsBySelector = function(selector) {
  for (var len = this.pages_.length, result = [], i = 0;i < len;i++) {
    var elements = this.pages_[i].querySelectorAll(selector);
    elements && (result = result.concat(Array.prototype.slice.call(elements)));
  }
  return result;
};
GWDPageDeckElementImpl.prototype.attributeChangedCallback = GWDCustomElementConstants.nullFunction;
document.registerElement(GwdPageDeckConstants.TAG_NAME, {prototype:GWDPageDeckElementImpl.prototype, "extends":GwdPageDeckConstants.EXTENDS_TAG_NAME});

})();
