(function(){
"use strict";
var GwdPageConstants = {TAG_NAME:"gwd-page", EXTENDS_TAG_NAME:"div", Attributes:{EXPANDED:"expanded", CENTERED:"centered", ALT_ORIENTATION_PAGE:"alt-orientation-page", PAGE_WIDTH:"data-gwd-width", PAGE_HEIGHT:"data-gwd-height"}, Events:{PAGE_PRESENTING:"pagepresenting", PAGE_ACTIVATED:"pageactivated", PAGE_DEACTIVATED:"pagedeactivated"}, PLAY_ANIMATION:"gwd-play-animation", INACTIVE:"gwd-inactive", COMPONENT_TAG_PREFIX:"gwd-"};
var DomUtil = {CLASS_NAME_SELECTOR_PREFIX_:".", REFLOW_ATTRIBUTE_NAME_:"gwd-reflow", NodeType:{ELEMENT:1, ATTRIBUTE:2, TEXT:3, CDATA_SECTION:4, ENTITY_REFERENCE:5, ENTITY:6, PROCESSING_INSTRUCTION:7, COMMENT:8, DOCUMENT:9, DOCUMENT_TYPE:10, DOCUMENT_FRAGMENT:11, NOTATION:12}, selectByClassName:function(root, className) {
  return root.querySelector(DomUtil.CLASS_NAME_SELECTOR_PREFIX_ + className);
}, contains:function(parent, descendant) {
  if (parent.contains && descendant.nodeType == DomUtil.NodeType.ELEMENT) {
    return parent == descendant || parent.contains(descendant);
  }
  if ("undefined" != typeof parent.compareDocumentPosition) {
    return parent == descendant || Boolean(parent.compareDocumentPosition(descendant) & 16);
  }
  for (;descendant && parent != descendant;) {
    descendant = descendant.parentNode;
  }
  return descendant == parent;
}, maybeLoadElement:function(element) {
  if ("function" == typeof element.gwdLoad && "function" == typeof element.gwdIsLoaded && !element.gwdIsLoaded()) {
    var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsLoaded = wrapperPage && "function" == typeof wrapperPage.gwdIsLoaded;
    (!wrapperPage || wrapperPageImplementsIsLoaded && wrapperPage.gwdIsLoaded()) && element.gwdLoad();
  }
}, maybeActivateElement:function(element) {
  if (null == element.gwdActivate || "function" == typeof element.gwdActivate) {
    if (null == element.gwdIsActive || !element.gwdIsActive()) {
      var wrapperPage = DomUtil.closest(element, DomUtil.isGwdPage_), wrapperPageImplementsIsActive = wrapperPage && null != wrapperPage.gwdIsActive && "function" == typeof wrapperPage.gwdIsActive;
      null == wrapperPage && element.gwdActivate();
      wrapperPageImplementsIsActive && wrapperPage.gwdIsActive() && element.gwdActivate();
    }
  }
}, isGwdPage_:function(element) {
  return element.tagName.toLowerCase() == GwdPageConstants.TAG_NAME || element.getAttribute("is") == GwdPageConstants.TAG_NAME;
}, closest:function(element, matcher) {
  if (matcher(element)) {
    return element;
  }
  for (;element && element.nodeType != DomUtil.NodeType.DOCUMENT;) {
    if ((element = element.parentElement) && matcher(element)) {
      return element;
    }
  }
  return null;
}, isAttachedToDom:function(element) {
  return !(element.ownerDocument.compareDocumentPosition(element) & Node.DOCUMENT_POSITION_DISCONNECTED);
}, createElement:function(tagName) {
  return document.createElement(tagName);
}, ancestors:function(child) {
  for (var ancestors = [], node = child;node;node = node.parentNode) {
    ancestors.unshift(node);
  }
  return ancestors;
}, commonAncestor:function(node1, node2) {
  for (var ancestors1 = DomUtil.ancestors(node1), ancestors2 = DomUtil.ancestors(node2), i = 0, a1 = ancestors1[0], a2 = ancestors2[0], commonAncestor = null;a1 && a2 && a1 == a2;) {
    commonAncestor = a1, i++, a1 = ancestors1[i], a2 = ancestors2[i];
  }
  return commonAncestor;
}, reflow:function(element) {
  element.setAttribute(DomUtil.REFLOW_ATTRIBUTE_NAME_, element.offsetWidth);
}, getIntegerAttribute:function(element, name, defaultValue) {
  var value = parseInt(element.getAttribute(name), 10);
  isNaN(value) && (value = defaultValue);
  return value;
}, getFloatAttribute:function(element, name, defaultValue) {
  var value = parseFloat(element.getAttribute(name));
  isFinite(value) || (value = defaultValue);
  return value;
}, getStringAttribute:function(element, name, defaultValue) {
  return element.hasAttribute(name) ? element.getAttribute(name) : defaultValue;
}, getBooleanAttribute:function(element, name, defaultValue) {
  switch(element.getAttribute(name)) {
    case "true":
      return !0;
    case "false":
      return !1;
    default:
      return defaultValue;
  }
}, setAttributeIfDifferent:function(element, name, value) {
  return value != element.getAttribute(name) ? (element.setAttribute(name, value), !0) : !1;
}, copyAttribute:function(sourceEl, sourceName, destEl, opt_destName) {
  opt_destName = opt_destName || sourceName;
  if (sourceEl.hasAttribute(sourceName)) {
    var value = sourceEl.getAttribute(sourceName);
    destEl.setAttribute(opt_destName, value);
  } else {
    destEl.removeAttribute(opt_destName);
  }
}};
var GwdDoubleClickConstants = {EVENT_DETAIL_URL:"url", EXPANDED_PAGE:"data-gwd-expanded", FULLSCREEN_CLASS_NAME:"fs", GWD_DATABINDER:"gwd-data-binder", GWD_YOUTUBE:"gwd-youtube", HANDLED:"handled", HTML_AUDIO:"audio", HTML_VIDEO:"video", START_PAGE_TRANSITION_DELAY:30, TAG_NAME:"gwd-doubleclick", Attributes:{DATA_PROVIDER:"data-provider", FULLSCREEN:"fullscreen", POLITE_LOAD:"polite-load"}, Events:{AD_INITIALIZED:"adinitialized", COLLAPSE_FINISH:"collapsefinish", COLLAPSE_START:"collapsestart", EXPAND_FINISH:"expandfinish", 
EXPAND_START:"expandstart", FULLSCREEN_SUPPORT:"fullscreensupport"}};
var BrowserUtil = {Orientation:{PORTRAIT:1, LANDSCAPE:2}, getUserAgentString_:function() {
  return window.navigator.userAgent || "";
}, isWebKit:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("WebKit");
}, isAndroid:function() {
  return -1 != BrowserUtil.getUserAgentString_().indexOf("Android");
}, isFirefox:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 != userAgent.indexOf("rv:") && -1 != userAgent.indexOf("Gecko");
}, isIE:function() {
  var userAgent = BrowserUtil.getUserAgentString_();
  return -1 < userAgent.indexOf("Trident") || -1 < userAgent.indexOf("MSIE");
}, isGwdDoubleClick_:function(element) {
  return element.tagName.toLowerCase() == GwdDoubleClickConstants.TAG_NAME;
}, openUrl:function(url) {
  window.open(url);
}, getOrientation:function() {
  return BrowserUtil.isPortrait_() ? BrowserUtil.Orientation.PORTRAIT : BrowserUtil.Orientation.LANDSCAPE;
}, isPortrait_:function() {
  return window.innerHeight >= window.innerWidth;
}, getQueryString:function() {
  return window.location.search;
}, setQueryString:function(queryString) {
  window.location.search = queryString;
}};
var ClockUtil = {setTimeout:function(callback, delay) {
  return setTimeout(callback, delay);
}, clearTimeout:function(timeoutId) {
  clearTimeout(timeoutId);
}, setInterval:function(callback, delay) {
  return setInterval(callback, delay);
}, clearInterval:function(intervalId) {
  clearInterval(intervalId);
}};
var EventTypes = {ABORT:"abort", ATTACHED:"attached", CAN_PLAY:"canplay", CLICK:"click", DETACHED:"detached", DRAG_END:"dragend", ERROR:"error", HOVER:"hover", HOVER_END:"hoverend", LOAD:"load", MOUSE_DOWN:"mousedown", MOUSE_MOVE:"mousemove", MOUSE_OUT:"mouseout", MOUSE_OVER:"mouseover", MOUSE_UP:"mouseup", PAGE_LOAD:"pageload", POINTER_CANCEL:"pointercancel", POINTER_DOWN:"pointerdown", POINTER_MOVE:"pointermove", POINTER_OUT:"pointerout", POINTER_OVER:"pointerover", POINTER_UP:"pointerup", READY:"ready", 
RESIZE:"resize", ROTATE_TO_PORTRAIT:"rotatetoportrait", ROTATE_TO_LANDSCAPE:"rotatetolandscape", SHAKE:"shake", SUBMIT:"submit", TAP:"tap", TILT:"tilt", TOUCH_END:"touchend", TOUCH_MOVE:"touchmove", TOUCH_START:"touchstart", TRACK:"track", TRACK_END:"trackend", TRACK_START:"trackstart", SWIPE_LEFT:"swipeleft", SWIPE_RIGHT:"swiperight", SWIPE_UP:"swipeup", SWIPE_DOWN:"swipedown", TRANSITION_END:"transitionend", WEB_COMPONENTS_READY:"WebComponentsReady", WEBGL_CONTEXT_LOST:"webglcontextlost", WEBGL_CONTEXT_RESTORED:"webglcontextrestored", 
WEBKIT_TRANSITION_END:"webkitTransitionEnd"}, EventUtil = {dispatch:function(eventName, source, opt_detail) {
  var event;
  opt_detail ? (event = document.createEvent("CustomEvent"), event.initCustomEvent(eventName, !0, !0, opt_detail)) : (event = document.createEvent("Event"), event.initEvent(eventName, !0, !0));
  source.dispatchEvent(event);
  return event;
}, dispatchAsync:function(eventName, source, opt_detail, opt_callback) {
  ClockUtil.setTimeout(function() {
    var evt = EventUtil.dispatch(eventName, source, opt_detail);
    opt_callback && opt_callback(evt);
  }, 0);
}, listenOnce:function(source, eventName, handler) {
  var listenOnceHandler = function(e) {
    source.removeEventListener(eventName, listenOnceHandler);
    handler(e);
  };
  source.addEventListener(eventName, listenOnceHandler);
}, BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_:5E12, getNormalizedEventTimeStamp:function(event) {
  var timeStamp = event.timeStamp;
  return timeStamp < EventUtil.BETWEEN_MILLI_AND_MICRO_TIME_STAMPS_ ? timeStamp : timeStamp / 1E3;
}};
var FileUtil = {getFullPath:function(src) {
  src = src.trim();
  return window.Enabler ? Enabler.getUrl(src) : src;
}};
var FullScreenUtil = {Events_:{GENERIC:"fullscreenchange", WEBKIT:"webkitfullscreenchange", MOZILLA:"mozfullscreenchange"}, Elements_:{GENERIC:"fullscreenElement", WEBKIT:"webkitFullscreenElement", MOZILLA:"mozFullScreenElement"}, getFullScreenElement_:function(doc) {
  var e, browserType;
  for (browserType in FullScreenUtil.Elements_) {
    var name = FullScreenUtil.Elements_[browserType];
    e = doc[name];
    if (void 0 !== e) {
      break;
    }
  }
  return e || null;
}, Handler:function(fullScreenClass, element, doc) {
  this.fullScreenClass_ = fullScreenClass;
  this.doc_ = doc;
  this.element_ = element;
  this.docListener_ = this.onDoc_.bind(this);
}};
FullScreenUtil.Handler.prototype.onDoc_ = function() {
  var fullScreenElement = FullScreenUtil.getFullScreenElement_(this.doc_);
  fullScreenElement ? this.element_ == fullScreenElement ? this.addClass_() : fullScreenElement.classList.contains(this.fullScreenClass_) ? this.removeClass_(DomUtil.commonAncestor(this.element_, fullScreenElement)) : this.removeClass_() : this.removeClass_();
};
FullScreenUtil.Handler.prototype.install = function() {
  for (var browserType in FullScreenUtil.Events_) {
    var name = FullScreenUtil.Events_[browserType];
    this.doc_.addEventListener(name, this.docListener_);
  }
};
FullScreenUtil.Handler.prototype.uninstall = function() {
  for (var browserType in FullScreenUtil.Events_) {
    var name = FullScreenUtil.Events_[browserType];
    this.doc_.removeEventListener(name, this.docListener_);
  }
  var fullScreenElement = FullScreenUtil.getFullScreenElement_(this.doc_);
  this.element_ == fullScreenElement && this.removeClass_();
};
FullScreenUtil.Handler.prototype.addClass_ = function() {
  for (var until = this.doc_, p = this.element_;p && p != until;p = p.parentNode) {
    p.classList.add(this.fullScreenClass_);
  }
};
FullScreenUtil.Handler.prototype.removeClass_ = function(opt_until) {
  for (var until = opt_until || this.doc_, p = this.element_;p && p != until;p = p.parentNode) {
    p.classList.remove(this.fullScreenClass_);
  }
};
var GwdVideoConstants_ = {FULLSCREEN_CLASS:"has-fullscreen-gwd-video", MUTED_ATTRIBUTE:"muted", SOURCE_TAG:"source", SOURCES_ATTRIBUTE:"sources", SOURCES_ATTRIBUTE_DELIMITER:",", TAG_NAME:"gwd-video", EXTENDS_TAG_NAME:"video", WEBKIT_AIRPLAY:"x-webkit-airplay", DEFAULT_AIRPLAY_VALUE:"allow", WEBKIT_PLAYSINLINE:"webkit-playsinline", VideoEvents:{PLAYING:"playing", VOLUME_CHANGE:"volumechange"}}, GWDVideoElementImpl = function() {
};
goog.inherits(GWDVideoElementImpl, HTMLVideoElement);
GWDVideoElementImpl.prototype.createdCallback = function() {
  this.volumeChangeHandler_ = this.handleVolumeChange_.bind(this);
  this.fullScreenHandler_ = new FullScreenUtil.Handler(GwdVideoConstants_.FULLSCREEN_CLASS, this, document);
  this.isActive_ = this.isLoaded_ = !1;
  this.setAttribute(GwdVideoConstants_.WEBKIT_PLAYSINLINE, !0);
  this.setAttribute(GwdVideoConstants_.WEBKIT_AIRPLAY, GwdVideoConstants_.DEFAULT_AIRPLAY_VALUE);
  this.muted = this.hasAttribute(GwdVideoConstants_.MUTED_ATTRIBUTE);
  this.volume_ = 1;
  this.isMuted_ = !1;
  this.shouldApplyMuteHack_ = this.muted && BrowserUtil.isAndroid();
};
GWDVideoElementImpl.prototype.attachedCallback = function() {
  DomUtil.maybeLoadElement(this);
  DomUtil.maybeActivateElement(this);
  this.shouldApplyMuteHack_ && EventUtil.listenOnce(this, GwdVideoConstants_.VideoEvents.PLAYING, function() {
    this.shouldApplyMuteHack_ && (this.volume = 0);
  }.bind(this));
  this.addEventListener(GwdVideoConstants_.VideoEvents.VOLUME_CHANGE, this.volumeChangeHandler_, !1);
  this.fullScreenHandler_.install();
};
GWDVideoElementImpl.prototype.detachedCallback = function() {
  this.fullScreenHandler_.uninstall();
  this.shouldApplyMuteHack_ && (this.volume = 1);
  this.removeEventListener(GwdVideoConstants_.VideoEvents.VOLUME_CHANGE, this.volumeChangeHandler_, !1);
};
GWDVideoElementImpl.prototype.attributeChangedCallback = function(attributeName) {
  GwdVideoConstants_.SOURCES_ATTRIBUTE == attributeName && (this.setSources_(), this.load());
};
GWDVideoElementImpl.prototype.gwdActivate = function() {
  this.autoplay && this.paused && this.play();
  this.isActive_ = !0;
};
GWDVideoElementImpl.prototype.gwdDeactivate = function() {
  this.seek(0);
  this.pause();
  this.isActive_ = !1;
};
GWDVideoElementImpl.prototype.gwdIsActive = function() {
  return this.isActive_;
};
GWDVideoElementImpl.prototype.gwdLoad = function() {
  this.setSources_();
  this.isLoaded_ = !0;
  EventUtil.dispatch(EventTypes.READY, this);
};
GWDVideoElementImpl.prototype.gwdIsLoaded = function() {
  return this.isLoaded_;
};
GWDVideoElementImpl.prototype.mute = function() {
  this.shouldApplyMuteHack_ && (this.volume = 1);
  this.shouldApplyMuteHack_ = !1;
  this.muted = !this.muted;
};
GWDVideoElementImpl.prototype.replay = function() {
  this.seek(0);
  this.play();
};
GWDVideoElementImpl.prototype.seek = function(jumpTo) {
  this.currentTime = jumpTo;
};
GWDVideoElementImpl.prototype.handleVolumeChange_ = function() {
  !1 === this.isMuted_ && !0 === this.muted && 0 === this.volume_ && (this.volume = 1, this.muted = !1);
  this.volume_ = this.volume;
  this.isMuted_ = this.muted;
};
GWDVideoElementImpl.prototype.setVolume = function(volumeValue) {
  this.muted = 0 < volumeValue ? !1 : !0;
  this.volume_ = this.volume = volumeValue / 100;
  this.isMuted_ = this.muted;
};
GWDVideoElementImpl.prototype.setSources = function(sources) {
  this.setAttribute(GwdVideoConstants_.SOURCES_ATTRIBUTE, sources);
};
GWDVideoElementImpl.prototype.setSources_ = function() {
  for (var sourcesAttribute = this.getAttribute(GwdVideoConstants_.SOURCES_ATTRIBUTE), sources = sourcesAttribute ? sourcesAttribute.split(GwdVideoConstants_.SOURCES_ATTRIBUTE_DELIMITER) : [], child;child = this.firstChild;) {
    this.removeChild(child);
  }
  for (var i = 0;i < sources.length;++i) {
    var source = document.createElement(GwdVideoConstants_.SOURCE_TAG);
    source.src = FileUtil.getFullPath(sources[i]);
    this.appendChild(source);
  }
};
document.registerElement(GwdVideoConstants_.TAG_NAME, {prototype:GWDVideoElementImpl.prototype, "extends":GwdVideoConstants_.EXTENDS_TAG_NAME});

})();
